/* -*- Mode: C; c-basic-offset: 4 -*- */

#include <Python.h>



#line 4 "bonoboui.override"
#include <Python.h>
#define NO_IMPORT_PYGOBJECT
#include <pygobject.h>
#include <pyorbit.h>
#include <bonobo.h>
#include <bonobo/bonobo-ui-config-widget.h>
#line 15 "bonoboui.c"


/* ---------- types from other modules ---------- */
static PyTypeObject *_PyGObject_Type;
#define PyGObject_Type (*_PyGObject_Type)
static PyTypeObject *_PyGtkAccelGroup_Type;
#define PyGtkAccelGroup_Type (*_PyGtkAccelGroup_Type)
static PyTypeObject *_PyGtkBin_Type;
#define PyGtkBin_Type (*_PyGtkBin_Type)
static PyTypeObject *_PyGtkBox_Type;
#define PyGtkBox_Type (*_PyGtkBox_Type)
static PyTypeObject *_PyGtkContainer_Type;
#define PyGtkContainer_Type (*_PyGtkContainer_Type)
static PyTypeObject *_PyGtkDialog_Type;
#define PyGtkDialog_Type (*_PyGtkDialog_Type)
static PyTypeObject *_PyGtkImage_Type;
#define PyGtkImage_Type (*_PyGtkImage_Type)
static PyTypeObject *_PyGtkMenu_Type;
#define PyGtkMenu_Type (*_PyGtkMenu_Type)
static PyTypeObject *_PyGtkMenuBar_Type;
#define PyGtkMenuBar_Type (*_PyGtkMenuBar_Type)
static PyTypeObject *_PyGtkPlug_Type;
#define PyGtkPlug_Type (*_PyGtkPlug_Type)
static PyTypeObject *_PyGtkSocket_Type;
#define PyGtkSocket_Type (*_PyGtkSocket_Type)
static PyTypeObject *_PyGtkTooltips_Type;
#define PyGtkTooltips_Type (*_PyGtkTooltips_Type)
static PyTypeObject *_PyGtkVBox_Type;
#define PyGtkVBox_Type (*_PyGtkVBox_Type)
static PyTypeObject *_PyGtkWidget_Type;
#define PyGtkWidget_Type (*_PyGtkWidget_Type)
static PyTypeObject *_PyGtkWindow_Type;
#define PyGtkWindow_Type (*_PyGtkWindow_Type)
static PyTypeObject *_PyGdkPixbuf_Type;
#define PyGdkPixbuf_Type (*_PyGdkPixbuf_Type)
static PyTypeObject *_PyGnomeCanvasItem_Type;
#define PyGnomeCanvasItem_Type (*_PyGnomeCanvasItem_Type)
static PyTypeObject *_PyBonoboObject_Type;
#define PyBonoboObject_Type (*_PyBonoboObject_Type)


/* ---------- forward type declarations ---------- */
PyTypeObject PyBonoboCanvasComponent_Type;
PyTypeObject PyBonoboCanvasItem_Type;
PyTypeObject PyBonoboControl_Type;
PyTypeObject PyBonoboControlFrame_Type;
PyTypeObject PyBonoboDock_Type;
PyTypeObject PyBonoboDockBand_Type;
PyTypeObject PyBonoboDockItem_Type;
PyTypeObject PyBonoboUIEngine_Type;
PyTypeObject PyBonoboPlug_Type;
PyTypeObject PyBonoboPropertyControl_Type;
PyTypeObject PyBonoboSelector_Type;
PyTypeObject PyBonoboSelectorWidget_Type;
PyTypeObject PyBonoboSocket_Type;
PyTypeObject PyBonoboUIComponent_Type;
PyTypeObject PyBonoboUIContainer_Type;
PyTypeObject PyBonoboUIToolbar_Type;
PyTypeObject PyBonoboUIToolbarItem_Type;
PyTypeObject PyBonoboWidget_Type;
PyTypeObject PyBonoboWindow_Type;


/* ----------- BonoboCanvasComponent ----------- */

static int
_wrap_bonobo_canvas_component_new(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "item", NULL };
    PyGObject *item;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!:BonoboCanvasComponent.__init__", kwlist, &PyGnomeCanvasItem_Type, &item))
        return -1;
    self->obj = (GObject *)bonobo_canvas_component_new(GNOME_CANVAS_ITEM(item->obj));

    if (!self->obj) {
        PyErr_SetString(PyExc_RuntimeError, "could not create BonoboCanvasComponent object");
        return -1;
    }
    pygobject_register_wrapper((PyObject *)self);
    return 0;
}

static PyObject *
_wrap_bonobo_canvas_component_get_item(PyGObject *self)
{
    GnomeCanvasItem *ret;

    ret = bonobo_canvas_component_get_item(BONOBO_CANVAS_COMPONENT(self->obj));
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyObject *
_wrap_bonobo_canvas_component_grab(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "mask", "cursor", "time", NULL };
    int mask;
    PyObject *py_cursor, *py_time = NULL;
    CORBA_Environment opt_ev;
    gulong time;
    GdkCursor *cursor = NULL;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "iOO!:BonoboCanvasComponent.grab", kwlist, &mask, &py_cursor, &PyLong_Type, &py_time))
        return NULL;
    if (pyg_boxed_check(py_cursor, GDK_TYPE_CURSOR))
        cursor = pyg_boxed_get(py_cursor, GdkCursor);
    else {
        PyErr_SetString(PyExc_TypeError, "cursor should be a GdkCursor");
        return NULL;
    }
    time = PyLong_AsUnsignedLong(py_time);
    CORBA_exception_init(&opt_ev);
    bonobo_canvas_component_grab(BONOBO_CANVAS_COMPONENT(self->obj), mask, cursor, time, &opt_ev);
    if (pyorbit_check_ex(&opt_ev))
        return NULL;
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_canvas_component_ungrab(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "time", NULL };
    PyObject *py_time = NULL;
    CORBA_Environment opt_ev;
    gulong time;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!:BonoboCanvasComponent.ungrab", kwlist, &PyLong_Type, &py_time))
        return NULL;
    time = PyLong_AsUnsignedLong(py_time);
    CORBA_exception_init(&opt_ev);
    bonobo_canvas_component_ungrab(BONOBO_CANVAS_COMPONENT(self->obj), time, &opt_ev);
    if (pyorbit_check_ex(&opt_ev))
        return NULL;
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_canvas_component_get_ui_container(PyGObject *self)
{
    CORBA_Environment opt_ev;
    Bonobo_UIContainer ret;

    CORBA_exception_init(&opt_ev);
    ret = bonobo_canvas_component_get_ui_container(BONOBO_CANVAS_COMPONENT(self->obj), &opt_ev);
    if (pyorbit_check_ex(&opt_ev))
        return NULL;
    if (ret != CORBA_OBJECT_NIL)
        return pycorba_object_new(ret);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyMethodDef _PyBonoboCanvasComponent_methods[] = {
    { "get_item", (PyCFunction)_wrap_bonobo_canvas_component_get_item, METH_NOARGS },
    { "grab", (PyCFunction)_wrap_bonobo_canvas_component_grab, METH_VARARGS|METH_KEYWORDS },
    { "ungrab", (PyCFunction)_wrap_bonobo_canvas_component_ungrab, METH_VARARGS|METH_KEYWORDS },
    { "get_ui_container", (PyCFunction)_wrap_bonobo_canvas_component_get_ui_container, METH_NOARGS },
    { NULL, NULL, 0 }
};

PyTypeObject PyBonoboCanvasComponent_Type = {
    PyObject_HEAD_INIT(NULL)
    0,					/* ob_size */
    "bonobo.ui.CanvasComponent",			/* tp_name */
    sizeof(PyGObject),	        /* tp_basicsize */
    0,					/* tp_itemsize */
    /* methods */
    (destructor)0,			/* tp_dealloc */
    (printfunc)0,			/* tp_print */
    (getattrfunc)0,	/* tp_getattr */
    (setattrfunc)0,	/* tp_setattr */
    (cmpfunc)0,		/* tp_compare */
    (reprfunc)0,		/* tp_repr */
    0,			/* tp_as_number */
    0,		/* tp_as_sequence */
    0,			/* tp_as_mapping */
    (hashfunc)0,		/* tp_hash */
    (ternaryfunc)0,		/* tp_call */
    (reprfunc)0,		/* tp_str */
    (getattrofunc)0,			/* tp_getattro */
    (setattrofunc)0,			/* tp_setattro */
    0,					/* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /* tp_flags */
    NULL, 				/* Documentation string */
    (traverseproc)0,			/* tp_traverse */
    (inquiry)0,			/* tp_clear */
    (richcmpfunc)0,	/* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,		/* tp_iter */
    (iternextfunc)0,	/* tp_iternext */
    _PyBonoboCanvasComponent_methods,			/* tp_methods */
    0,					/* tp_members */
    0,		       	/* tp_getset */
    NULL,				/* tp_base */
    NULL,				/* tp_dict */
    (descrgetfunc)0,	/* tp_descr_get */
    (descrsetfunc)0,	/* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)_wrap_bonobo_canvas_component_new,		/* tp_init */
};



/* ----------- BonoboCanvasItem ----------- */

static int
pygobject_no_constructor(PyObject *self, PyObject *args, PyObject *kwargs)
{
    gchar buf[512];

    g_snprintf(buf, sizeof(buf), "%s is an abstract widget", self->ob_type->tp_name);
    PyErr_SetString(PyExc_NotImplementedError, buf);
    return -1;
}

static PyObject *
_wrap_bonobo_canvas_item_set_bounds(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "x1", "y1", "x2", "y2", NULL };
    double x1, y1, x2, y2;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "dddd:BonoboCanvasItem.set_bounds", kwlist, &x1, &y1, &x2, &y2))
        return NULL;
    bonobo_canvas_item_set_bounds(BONOBO_CANVAS_ITEM(self->obj), x1, y1, x2, y2);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyMethodDef _PyBonoboCanvasItem_methods[] = {
    { "set_bounds", (PyCFunction)_wrap_bonobo_canvas_item_set_bounds, METH_VARARGS|METH_KEYWORDS },
    { NULL, NULL, 0 }
};

PyTypeObject PyBonoboCanvasItem_Type = {
    PyObject_HEAD_INIT(NULL)
    0,					/* ob_size */
    "bonobo.ui.CanvasItem",			/* tp_name */
    sizeof(PyGObject),	        /* tp_basicsize */
    0,					/* tp_itemsize */
    /* methods */
    (destructor)0,			/* tp_dealloc */
    (printfunc)0,			/* tp_print */
    (getattrfunc)0,	/* tp_getattr */
    (setattrfunc)0,	/* tp_setattr */
    (cmpfunc)0,		/* tp_compare */
    (reprfunc)0,		/* tp_repr */
    0,			/* tp_as_number */
    0,		/* tp_as_sequence */
    0,			/* tp_as_mapping */
    (hashfunc)0,		/* tp_hash */
    (ternaryfunc)0,		/* tp_call */
    (reprfunc)0,		/* tp_str */
    (getattrofunc)0,			/* tp_getattro */
    (setattrofunc)0,			/* tp_setattro */
    0,					/* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /* tp_flags */
    NULL, 				/* Documentation string */
    (traverseproc)0,			/* tp_traverse */
    (inquiry)0,			/* tp_clear */
    (richcmpfunc)0,	/* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,		/* tp_iter */
    (iternextfunc)0,	/* tp_iternext */
    _PyBonoboCanvasItem_methods,			/* tp_methods */
    0,					/* tp_members */
    0,		       	/* tp_getset */
    NULL,				/* tp_base */
    NULL,				/* tp_dict */
    (descrgetfunc)0,	/* tp_descr_get */
    (descrsetfunc)0,	/* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)pygobject_no_constructor,		/* tp_init */
};



/* ----------- BonoboControl ----------- */

static int
_wrap_bonobo_control_new(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "widget", NULL };
    PyGObject *widget;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!:BonoboControl.__init__", kwlist, &PyGtkWidget_Type, &widget))
        return -1;
    self->obj = (GObject *)bonobo_control_new(GTK_WIDGET(widget->obj));

    if (!self->obj) {
        PyErr_SetString(PyExc_RuntimeError, "could not create BonoboControl object");
        return -1;
    }
    pygobject_register_wrapper((PyObject *)self);
    return 0;
}

static PyObject *
_wrap_bonobo_control_get_widget(PyGObject *self)
{
    GtkWidget *ret;

    ret = bonobo_control_get_widget(BONOBO_CONTROL(self->obj));
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyObject *
_wrap_bonobo_control_set_automerge(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "automerge", NULL };
    int automerge;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "i:BonoboControl.set_automerge", kwlist, &automerge))
        return NULL;
    bonobo_control_set_automerge(BONOBO_CONTROL(self->obj), automerge);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_control_get_automerge(PyGObject *self)
{
    int ret;
    PyObject *py_ret;

    ret = bonobo_control_get_automerge(BONOBO_CONTROL(self->obj));
    py_ret = ret ? Py_True : Py_False;
    Py_INCREF(py_ret);
    return py_ret;
}

static PyObject *
_wrap_bonobo_control_set_transient_for(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "window", NULL };
    PyGObject *window;
    CORBA_Environment opt_ev;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!:BonoboControl.set_transient_for", kwlist, &PyGtkWindow_Type, &window))
        return NULL;
    CORBA_exception_init(&opt_ev);
    bonobo_control_set_transient_for(BONOBO_CONTROL(self->obj), GTK_WINDOW(window->obj), &opt_ev);
    if (pyorbit_check_ex(&opt_ev))
        return NULL;
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_control_unset_transient_for(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "window", NULL };
    PyGObject *window;
    CORBA_Environment opt_ev;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!:BonoboControl.unset_transient_for", kwlist, &PyGtkWindow_Type, &window))
        return NULL;
    CORBA_exception_init(&opt_ev);
    bonobo_control_unset_transient_for(BONOBO_CONTROL(self->obj), GTK_WINDOW(window->obj), &opt_ev);
    if (pyorbit_check_ex(&opt_ev))
        return NULL;
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_control_get_ui_component(PyGObject *self)
{
    BonoboUIComponent *ret;

    ret = bonobo_control_get_ui_component(BONOBO_CONTROL(self->obj));
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyObject *
_wrap_bonobo_control_set_ui_component(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "component", NULL };
    PyGObject *component;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!:BonoboControl.set_ui_component", kwlist, &PyBonoboUIComponent_Type, &component))
        return NULL;
    bonobo_control_set_ui_component(BONOBO_CONTROL(self->obj), BONOBO_UI_COMPONENT(component->obj));
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_control_get_remote_ui_container(PyGObject *self)
{
    CORBA_Environment opt_ev;
    Bonobo_UIContainer ret;

    CORBA_exception_init(&opt_ev);
    ret = bonobo_control_get_remote_ui_container(BONOBO_CONTROL(self->obj), &opt_ev);
    if (pyorbit_check_ex(&opt_ev))
        return NULL;
    if (ret != CORBA_OBJECT_NIL)
        return pycorba_object_new(ret);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_control_get_control_frame(PyGObject *self)
{
    CORBA_Environment opt_ev;
    Bonobo_ControlFrame ret;

    CORBA_exception_init(&opt_ev);
    ret = bonobo_control_get_control_frame(BONOBO_CONTROL(self->obj), &opt_ev);
    if (pyorbit_check_ex(&opt_ev))
        return NULL;
    if (ret != CORBA_OBJECT_NIL)
        return pycorba_object_new(ret);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_control_set_properties(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "pb", NULL };
    PyObject *pb;
    CORBA_Environment opt_ev;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!:BonoboControl.set_properties", kwlist, &PyCORBA_Object_Type, &pb))
        return NULL;
    CORBA_exception_init(&opt_ev);
    bonobo_control_set_properties(BONOBO_CONTROL(self->obj), (Bonobo_PropertyBag)((PyCORBA_Object *)pb)->objref, &opt_ev);
    if (pyorbit_check_ex(&opt_ev))
        return NULL;
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_control_get_properties(PyGObject *self)
{
    Bonobo_PropertyBag ret;

    ret = bonobo_control_get_properties(BONOBO_CONTROL(self->obj));
    if (ret != CORBA_OBJECT_NIL)
        return pycorba_object_new(ret);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_control_get_ambient_properties(PyGObject *self)
{
    CORBA_Environment opt_ev;
    Bonobo_PropertyBag ret;

    CORBA_exception_init(&opt_ev);
    ret = bonobo_control_get_ambient_properties(BONOBO_CONTROL(self->obj), &opt_ev);
    if (pyorbit_check_ex(&opt_ev))
        return NULL;
    if (ret != CORBA_OBJECT_NIL)
        return pycorba_object_new(ret);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_control_activate_notify(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "activated", NULL };
    int activated;
    CORBA_Environment opt_ev;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "i:BonoboControl.activate_notify", kwlist, &activated))
        return NULL;
    CORBA_exception_init(&opt_ev);
    bonobo_control_activate_notify(BONOBO_CONTROL(self->obj), activated, &opt_ev);
    if (pyorbit_check_ex(&opt_ev))
        return NULL;
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_control_get_popup_ui_component(PyGObject *self)
{
    BonoboUIComponent *ret;

    ret = bonobo_control_get_popup_ui_component(BONOBO_CONTROL(self->obj));
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyObject *
_wrap_bonobo_control_set_popup_ui_container(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "ui_container", NULL };
    PyGObject *ui_container;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!:BonoboControl.set_popup_ui_container", kwlist, &PyBonoboUIContainer_Type, &ui_container))
        return NULL;
    bonobo_control_set_popup_ui_container(BONOBO_CONTROL(self->obj), BONOBO_UI_CONTAINER(ui_container->obj));
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_control_do_popup(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "button", "activate_time", NULL };
    int button, ret;
    PyObject *py_activate_time = NULL, *py_ret;
    gulong activate_time;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "iO!:BonoboControl.do_popup", kwlist, &button, &PyLong_Type, &py_activate_time))
        return NULL;
    activate_time = PyLong_AsUnsignedLong(py_activate_time);
    ret = bonobo_control_do_popup(BONOBO_CONTROL(self->obj), button, activate_time);
    py_ret = ret ? Py_True : Py_False;
    Py_INCREF(py_ret);
    return py_ret;
}

static PyMethodDef _PyBonoboControl_methods[] = {
    { "get_widget", (PyCFunction)_wrap_bonobo_control_get_widget, METH_NOARGS },
    { "set_automerge", (PyCFunction)_wrap_bonobo_control_set_automerge, METH_VARARGS|METH_KEYWORDS },
    { "get_automerge", (PyCFunction)_wrap_bonobo_control_get_automerge, METH_NOARGS },
    { "set_transient_for", (PyCFunction)_wrap_bonobo_control_set_transient_for, METH_VARARGS|METH_KEYWORDS },
    { "unset_transient_for", (PyCFunction)_wrap_bonobo_control_unset_transient_for, METH_VARARGS|METH_KEYWORDS },
    { "get_ui_component", (PyCFunction)_wrap_bonobo_control_get_ui_component, METH_NOARGS },
    { "set_ui_component", (PyCFunction)_wrap_bonobo_control_set_ui_component, METH_VARARGS|METH_KEYWORDS },
    { "get_remote_ui_container", (PyCFunction)_wrap_bonobo_control_get_remote_ui_container, METH_NOARGS },
    { "get_control_frame", (PyCFunction)_wrap_bonobo_control_get_control_frame, METH_NOARGS },
    { "set_properties", (PyCFunction)_wrap_bonobo_control_set_properties, METH_VARARGS|METH_KEYWORDS },
    { "get_properties", (PyCFunction)_wrap_bonobo_control_get_properties, METH_NOARGS },
    { "get_ambient_properties", (PyCFunction)_wrap_bonobo_control_get_ambient_properties, METH_NOARGS },
    { "activate_notify", (PyCFunction)_wrap_bonobo_control_activate_notify, METH_VARARGS|METH_KEYWORDS },
    { "get_popup_ui_component", (PyCFunction)_wrap_bonobo_control_get_popup_ui_component, METH_NOARGS },
    { "set_popup_ui_container", (PyCFunction)_wrap_bonobo_control_set_popup_ui_container, METH_VARARGS|METH_KEYWORDS },
    { "do_popup", (PyCFunction)_wrap_bonobo_control_do_popup, METH_VARARGS|METH_KEYWORDS },
    { NULL, NULL, 0 }
};

PyTypeObject PyBonoboControl_Type = {
    PyObject_HEAD_INIT(NULL)
    0,					/* ob_size */
    "bonobo.ui.Control",			/* tp_name */
    sizeof(PyGObject),	        /* tp_basicsize */
    0,					/* tp_itemsize */
    /* methods */
    (destructor)0,			/* tp_dealloc */
    (printfunc)0,			/* tp_print */
    (getattrfunc)0,	/* tp_getattr */
    (setattrfunc)0,	/* tp_setattr */
    (cmpfunc)0,		/* tp_compare */
    (reprfunc)0,		/* tp_repr */
    0,			/* tp_as_number */
    0,		/* tp_as_sequence */
    0,			/* tp_as_mapping */
    (hashfunc)0,		/* tp_hash */
    (ternaryfunc)0,		/* tp_call */
    (reprfunc)0,		/* tp_str */
    (getattrofunc)0,			/* tp_getattro */
    (setattrofunc)0,			/* tp_setattro */
    0,					/* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /* tp_flags */
    NULL, 				/* Documentation string */
    (traverseproc)0,			/* tp_traverse */
    (inquiry)0,			/* tp_clear */
    (richcmpfunc)0,	/* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,		/* tp_iter */
    (iternextfunc)0,	/* tp_iternext */
    _PyBonoboControl_methods,			/* tp_methods */
    0,					/* tp_members */
    0,		       	/* tp_getset */
    NULL,				/* tp_base */
    NULL,				/* tp_dict */
    (descrgetfunc)0,	/* tp_descr_get */
    (descrsetfunc)0,	/* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)_wrap_bonobo_control_new,		/* tp_init */
};



/* ----------- BonoboControlFrame ----------- */

static int
_wrap_bonobo_control_frame_new(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "ui_container", NULL };
    PyObject *ui_container;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!:BonoboControlFrame.__init__", kwlist, &PyCORBA_Object_Type, &ui_container))
        return -1;
    self->obj = (GObject *)bonobo_control_frame_new((Bonobo_UIContainer)((PyCORBA_Object *)ui_container)->objref);

    if (!self->obj) {
        PyErr_SetString(PyExc_RuntimeError, "could not create BonoboControlFrame object");
        return -1;
    }
    pygobject_register_wrapper((PyObject *)self);
    return 0;
}

static PyObject *
_wrap_bonobo_control_frame_get_widget(PyGObject *self)
{
    GtkWidget *ret;

    ret = bonobo_control_frame_get_widget(BONOBO_CONTROL_FRAME(self->obj));
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyObject *
_wrap_bonobo_control_frame_set_ui_container(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "uic", NULL };
    PyObject *uic;
    CORBA_Environment ev;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!:BonoboControlFrame.set_ui_container", kwlist, &PyCORBA_Object_Type, &uic))
        return NULL;
    CORBA_exception_init(&ev);
    bonobo_control_frame_set_ui_container(BONOBO_CONTROL_FRAME(self->obj), (Bonobo_UIContainer)((PyCORBA_Object *)uic)->objref, &ev);
    if (pyorbit_check_ex(&ev))
        return NULL;
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_control_frame_control_activate(PyGObject *self)
{
    bonobo_control_frame_control_activate(BONOBO_CONTROL_FRAME(self->obj));
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_control_frame_control_deactivate(PyGObject *self)
{
    bonobo_control_frame_control_deactivate(BONOBO_CONTROL_FRAME(self->obj));
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_control_frame_set_autoactivate(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "autoactivate", NULL };
    int autoactivate;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "i:BonoboControlFrame.set_autoactivate", kwlist, &autoactivate))
        return NULL;
    bonobo_control_frame_set_autoactivate(BONOBO_CONTROL_FRAME(self->obj), autoactivate);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_control_frame_get_autoactivate(PyGObject *self)
{
    int ret;
    PyObject *py_ret;

    ret = bonobo_control_frame_get_autoactivate(BONOBO_CONTROL_FRAME(self->obj));
    py_ret = ret ? Py_True : Py_False;
    Py_INCREF(py_ret);
    return py_ret;
}

static PyObject *
_wrap_bonobo_control_frame_get_control_property_bag(PyGObject *self)
{
    CORBA_Environment opt_ev;
    Bonobo_PropertyBag ret;

    CORBA_exception_init(&opt_ev);
    ret = bonobo_control_frame_get_control_property_bag(BONOBO_CONTROL_FRAME(self->obj), &opt_ev);
    if (pyorbit_check_ex(&opt_ev))
        return NULL;
    if (ret != CORBA_OBJECT_NIL)
        return pycorba_object_new(ret);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_control_frame_control_set_state(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "state", NULL };
    PyObject *py_state = NULL;
    GtkStateType state;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O:BonoboControlFrame.control_set_state", kwlist, &py_state))
        return NULL;
    if (pyg_enum_get_value(GTK_TYPE_STATE_TYPE, py_state, (gint *)&state))
        return NULL;
    bonobo_control_frame_control_set_state(BONOBO_CONTROL_FRAME(self->obj), state);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_control_frame_set_autostate(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "autostate", NULL };
    int autostate;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "i:BonoboControlFrame.set_autostate", kwlist, &autostate))
        return NULL;
    bonobo_control_frame_set_autostate(BONOBO_CONTROL_FRAME(self->obj), autostate);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_control_frame_get_autostate(PyGObject *self)
{
    int ret;
    PyObject *py_ret;

    ret = bonobo_control_frame_get_autostate(BONOBO_CONTROL_FRAME(self->obj));
    py_ret = ret ? Py_True : Py_False;
    Py_INCREF(py_ret);
    return py_ret;
}

static PyObject *
_wrap_bonobo_control_frame_bind_to_control(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "control", NULL };
    PyObject *control;
    CORBA_Environment opt_ev;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!:BonoboControlFrame.bind_to_control", kwlist, &PyCORBA_Object_Type, &control))
        return NULL;
    CORBA_exception_init(&opt_ev);
    bonobo_control_frame_bind_to_control(BONOBO_CONTROL_FRAME(self->obj), (Bonobo_Control)((PyCORBA_Object *)control)->objref, &opt_ev);
    if (pyorbit_check_ex(&opt_ev))
        return NULL;
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_control_frame_get_control(PyGObject *self)
{
    Bonobo_Control ret;

    ret = bonobo_control_frame_get_control(BONOBO_CONTROL_FRAME(self->obj));
    if (ret != CORBA_OBJECT_NIL)
        return pycorba_object_new(ret);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_control_frame_get_ui_container(PyGObject *self)
{
    Bonobo_UIContainer ret;

    ret = bonobo_control_frame_get_ui_container(BONOBO_CONTROL_FRAME(self->obj));
    if (ret != CORBA_OBJECT_NIL)
        return pycorba_object_new(ret);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_control_frame_get_popup_component(PyGObject *self)
{
    CORBA_Environment opt_ev;
    BonoboUIComponent *ret;

    CORBA_exception_init(&opt_ev);
    ret = bonobo_control_frame_get_popup_component(BONOBO_CONTROL_FRAME(self->obj), &opt_ev);
    if (pyorbit_check_ex(&opt_ev))
        return NULL;
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyMethodDef _PyBonoboControlFrame_methods[] = {
    { "get_widget", (PyCFunction)_wrap_bonobo_control_frame_get_widget, METH_NOARGS },
    { "set_ui_container", (PyCFunction)_wrap_bonobo_control_frame_set_ui_container, METH_VARARGS|METH_KEYWORDS },
    { "control_activate", (PyCFunction)_wrap_bonobo_control_frame_control_activate, METH_NOARGS },
    { "control_deactivate", (PyCFunction)_wrap_bonobo_control_frame_control_deactivate, METH_NOARGS },
    { "set_autoactivate", (PyCFunction)_wrap_bonobo_control_frame_set_autoactivate, METH_VARARGS|METH_KEYWORDS },
    { "get_autoactivate", (PyCFunction)_wrap_bonobo_control_frame_get_autoactivate, METH_NOARGS },
    { "get_control_property_bag", (PyCFunction)_wrap_bonobo_control_frame_get_control_property_bag, METH_NOARGS },
    { "control_set_state", (PyCFunction)_wrap_bonobo_control_frame_control_set_state, METH_VARARGS|METH_KEYWORDS },
    { "set_autostate", (PyCFunction)_wrap_bonobo_control_frame_set_autostate, METH_VARARGS|METH_KEYWORDS },
    { "get_autostate", (PyCFunction)_wrap_bonobo_control_frame_get_autostate, METH_NOARGS },
    { "bind_to_control", (PyCFunction)_wrap_bonobo_control_frame_bind_to_control, METH_VARARGS|METH_KEYWORDS },
    { "get_control", (PyCFunction)_wrap_bonobo_control_frame_get_control, METH_NOARGS },
    { "get_ui_container", (PyCFunction)_wrap_bonobo_control_frame_get_ui_container, METH_NOARGS },
    { "get_popup_component", (PyCFunction)_wrap_bonobo_control_frame_get_popup_component, METH_NOARGS },
    { NULL, NULL, 0 }
};

PyTypeObject PyBonoboControlFrame_Type = {
    PyObject_HEAD_INIT(NULL)
    0,					/* ob_size */
    "bonobo.ui.ControlFrame",			/* tp_name */
    sizeof(PyGObject),	        /* tp_basicsize */
    0,					/* tp_itemsize */
    /* methods */
    (destructor)0,			/* tp_dealloc */
    (printfunc)0,			/* tp_print */
    (getattrfunc)0,	/* tp_getattr */
    (setattrfunc)0,	/* tp_setattr */
    (cmpfunc)0,		/* tp_compare */
    (reprfunc)0,		/* tp_repr */
    0,			/* tp_as_number */
    0,		/* tp_as_sequence */
    0,			/* tp_as_mapping */
    (hashfunc)0,		/* tp_hash */
    (ternaryfunc)0,		/* tp_call */
    (reprfunc)0,		/* tp_str */
    (getattrofunc)0,			/* tp_getattro */
    (setattrofunc)0,			/* tp_setattro */
    0,					/* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /* tp_flags */
    NULL, 				/* Documentation string */
    (traverseproc)0,			/* tp_traverse */
    (inquiry)0,			/* tp_clear */
    (richcmpfunc)0,	/* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,		/* tp_iter */
    (iternextfunc)0,	/* tp_iternext */
    _PyBonoboControlFrame_methods,			/* tp_methods */
    0,					/* tp_members */
    0,		       	/* tp_getset */
    NULL,				/* tp_base */
    NULL,				/* tp_dict */
    (descrgetfunc)0,	/* tp_descr_get */
    (descrsetfunc)0,	/* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)_wrap_bonobo_control_frame_new,		/* tp_init */
};



/* ----------- BonoboDock ----------- */

static int
_wrap_bonobo_dock_new(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { NULL };

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, ":BonoboDock.__init__", kwlist))
        return -1;
    self->obj = (GObject *)bonobo_dock_new();

    if (!self->obj) {
        PyErr_SetString(PyExc_RuntimeError, "could not create BonoboDock object");
        return -1;
    }
    pygobject_register_wrapper((PyObject *)self);
    return 0;
}

static PyObject *
_wrap_bonobo_dock_allow_floating_items(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "enable", NULL };
    int enable;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "i:BonoboDock.allow_floating_items", kwlist, &enable))
        return NULL;
    bonobo_dock_allow_floating_items(BONOBO_DOCK(self->obj), enable);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_dock_add_item(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "item", "placement", "band_num", "position", "offset", "in_new_band", NULL };
    PyGObject *item;
    PyObject *py_placement = NULL;
    BonoboDockPlacement placement;
    int band_num, position, offset, in_new_band;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!Oiiii:BonoboDock.add_item", kwlist, &PyBonoboDockItem_Type, &item, &py_placement, &band_num, &position, &offset, &in_new_band))
        return NULL;
    if (pyg_enum_get_value(BONOBO_TYPE_DOCK_PLACEMENT, py_placement, (gint *)&placement))
        return NULL;
    bonobo_dock_add_item(BONOBO_DOCK(self->obj), BONOBO_DOCK_ITEM(item->obj), placement, band_num, position, offset, in_new_band);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_dock_add_floating_item(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "widget", "x", "y", "orientation", NULL };
    PyGObject *widget;
    int x, y;
    GtkOrientation orientation;
    PyObject *py_orientation = NULL;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!iiO:BonoboDock.add_floating_item", kwlist, &PyBonoboDockItem_Type, &widget, &x, &y, &py_orientation))
        return NULL;
    if (pyg_enum_get_value(GTK_TYPE_ORIENTATION, py_orientation, (gint *)&orientation))
        return NULL;
    bonobo_dock_add_floating_item(BONOBO_DOCK(self->obj), BONOBO_DOCK_ITEM(widget->obj), x, y, orientation);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_dock_set_client_area(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "widget", NULL };
    PyGObject *widget;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!:BonoboDock.set_client_area", kwlist, &PyGtkWidget_Type, &widget))
        return NULL;
    bonobo_dock_set_client_area(BONOBO_DOCK(self->obj), GTK_WIDGET(widget->obj));
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_dock_get_client_area(PyGObject *self)
{
    GtkWidget *ret;

    ret = bonobo_dock_get_client_area(BONOBO_DOCK(self->obj));
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyMethodDef _PyBonoboDock_methods[] = {
    { "allow_floating_items", (PyCFunction)_wrap_bonobo_dock_allow_floating_items, METH_VARARGS|METH_KEYWORDS },
    { "add_item", (PyCFunction)_wrap_bonobo_dock_add_item, METH_VARARGS|METH_KEYWORDS },
    { "add_floating_item", (PyCFunction)_wrap_bonobo_dock_add_floating_item, METH_VARARGS|METH_KEYWORDS },
    { "set_client_area", (PyCFunction)_wrap_bonobo_dock_set_client_area, METH_VARARGS|METH_KEYWORDS },
    { "get_client_area", (PyCFunction)_wrap_bonobo_dock_get_client_area, METH_NOARGS },
    { NULL, NULL, 0 }
};

PyTypeObject PyBonoboDock_Type = {
    PyObject_HEAD_INIT(NULL)
    0,					/* ob_size */
    "bonobo.ui.Dock",			/* tp_name */
    sizeof(PyGObject),	        /* tp_basicsize */
    0,					/* tp_itemsize */
    /* methods */
    (destructor)0,			/* tp_dealloc */
    (printfunc)0,			/* tp_print */
    (getattrfunc)0,	/* tp_getattr */
    (setattrfunc)0,	/* tp_setattr */
    (cmpfunc)0,		/* tp_compare */
    (reprfunc)0,		/* tp_repr */
    0,			/* tp_as_number */
    0,		/* tp_as_sequence */
    0,			/* tp_as_mapping */
    (hashfunc)0,		/* tp_hash */
    (ternaryfunc)0,		/* tp_call */
    (reprfunc)0,		/* tp_str */
    (getattrofunc)0,			/* tp_getattro */
    (setattrofunc)0,			/* tp_setattro */
    0,					/* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /* tp_flags */
    NULL, 				/* Documentation string */
    (traverseproc)0,			/* tp_traverse */
    (inquiry)0,			/* tp_clear */
    (richcmpfunc)0,	/* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,		/* tp_iter */
    (iternextfunc)0,	/* tp_iternext */
    _PyBonoboDock_methods,			/* tp_methods */
    0,					/* tp_members */
    0,		       	/* tp_getset */
    NULL,				/* tp_base */
    NULL,				/* tp_dict */
    (descrgetfunc)0,	/* tp_descr_get */
    (descrsetfunc)0,	/* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)_wrap_bonobo_dock_new,		/* tp_init */
};



/* ----------- BonoboDockBand ----------- */

static int
_wrap_bonobo_dock_band_new(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { NULL };

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, ":BonoboDockBand.__init__", kwlist))
        return -1;
    self->obj = (GObject *)bonobo_dock_band_new();

    if (!self->obj) {
        PyErr_SetString(PyExc_RuntimeError, "could not create BonoboDockBand object");
        return -1;
    }
    pygobject_register_wrapper((PyObject *)self);
    return 0;
}

static PyObject *
_wrap_bonobo_dock_band_set_orientation(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "orientation", NULL };
    GtkOrientation orientation;
    PyObject *py_orientation = NULL;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O:BonoboDockBand.set_orientation", kwlist, &py_orientation))
        return NULL;
    if (pyg_enum_get_value(GTK_TYPE_ORIENTATION, py_orientation, (gint *)&orientation))
        return NULL;
    bonobo_dock_band_set_orientation(BONOBO_DOCK_BAND(self->obj), orientation);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_dock_band_get_orientation(PyGObject *self)
{
    gint ret;

    ret = bonobo_dock_band_get_orientation(BONOBO_DOCK_BAND(self->obj));
    return PyInt_FromLong(ret);
}

static PyObject *
_wrap_bonobo_dock_band_insert(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "child", "offset", "position", NULL };
    PyGObject *child;
    int offset, position, ret;
    PyObject *py_ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!ii:BonoboDockBand.insert", kwlist, &PyGtkWidget_Type, &child, &offset, &position))
        return NULL;
    ret = bonobo_dock_band_insert(BONOBO_DOCK_BAND(self->obj), GTK_WIDGET(child->obj), offset, position);
    py_ret = ret ? Py_True : Py_False;
    Py_INCREF(py_ret);
    return py_ret;
}

static PyObject *
_wrap_bonobo_dock_band_prepend(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "child", "offset", NULL };
    PyGObject *child;
    int offset, ret;
    PyObject *py_ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!i:BonoboDockBand.prepend", kwlist, &PyGtkWidget_Type, &child, &offset))
        return NULL;
    ret = bonobo_dock_band_prepend(BONOBO_DOCK_BAND(self->obj), GTK_WIDGET(child->obj), offset);
    py_ret = ret ? Py_True : Py_False;
    Py_INCREF(py_ret);
    return py_ret;
}

static PyObject *
_wrap_bonobo_dock_band_append(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "child", "offset", NULL };
    PyGObject *child;
    int offset, ret;
    PyObject *py_ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!i:BonoboDockBand.append", kwlist, &PyGtkWidget_Type, &child, &offset))
        return NULL;
    ret = bonobo_dock_band_append(BONOBO_DOCK_BAND(self->obj), GTK_WIDGET(child->obj), offset);
    py_ret = ret ? Py_True : Py_False;
    Py_INCREF(py_ret);
    return py_ret;
}

static PyObject *
_wrap_bonobo_dock_band_set_child_offset(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "child", "offset", NULL };
    PyGObject *child;
    int offset;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!i:BonoboDockBand.set_child_offset", kwlist, &PyGtkWidget_Type, &child, &offset))
        return NULL;
    bonobo_dock_band_set_child_offset(BONOBO_DOCK_BAND(self->obj), GTK_WIDGET(child->obj), offset);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_dock_band_get_child_offset(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "child", NULL };
    PyGObject *child;
    int ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!:BonoboDockBand.get_child_offset", kwlist, &PyGtkWidget_Type, &child))
        return NULL;
    ret = bonobo_dock_band_get_child_offset(BONOBO_DOCK_BAND(self->obj), GTK_WIDGET(child->obj));
    return PyInt_FromLong(ret);
}

static PyObject *
_wrap_bonobo_dock_band_get_num_children(PyGObject *self)
{
    int ret;

    ret = bonobo_dock_band_get_num_children(BONOBO_DOCK_BAND(self->obj));
    return PyInt_FromLong(ret);
}

static PyObject *
_wrap_bonobo_dock_band_drag_begin(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "item", NULL };
    PyGObject *item;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!:BonoboDockBand.drag_begin", kwlist, &PyBonoboDockItem_Type, &item))
        return NULL;
    bonobo_dock_band_drag_begin(BONOBO_DOCK_BAND(self->obj), BONOBO_DOCK_ITEM(item->obj));
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_dock_band_drag_to(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "item", "x", "y", NULL };
    PyGObject *item;
    int x, y, ret;
    PyObject *py_ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!ii:BonoboDockBand.drag_to", kwlist, &PyBonoboDockItem_Type, &item, &x, &y))
        return NULL;
    ret = bonobo_dock_band_drag_to(BONOBO_DOCK_BAND(self->obj), BONOBO_DOCK_ITEM(item->obj), x, y);
    py_ret = ret ? Py_True : Py_False;
    Py_INCREF(py_ret);
    return py_ret;
}

static PyObject *
_wrap_bonobo_dock_band_drag_end(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "item", NULL };
    PyGObject *item;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!:BonoboDockBand.drag_end", kwlist, &PyBonoboDockItem_Type, &item))
        return NULL;
    bonobo_dock_band_drag_end(BONOBO_DOCK_BAND(self->obj), BONOBO_DOCK_ITEM(item->obj));
    Py_INCREF(Py_None);
    return Py_None;
}

static PyMethodDef _PyBonoboDockBand_methods[] = {
    { "set_orientation", (PyCFunction)_wrap_bonobo_dock_band_set_orientation, METH_VARARGS|METH_KEYWORDS },
    { "get_orientation", (PyCFunction)_wrap_bonobo_dock_band_get_orientation, METH_NOARGS },
    { "insert", (PyCFunction)_wrap_bonobo_dock_band_insert, METH_VARARGS|METH_KEYWORDS },
    { "prepend", (PyCFunction)_wrap_bonobo_dock_band_prepend, METH_VARARGS|METH_KEYWORDS },
    { "append", (PyCFunction)_wrap_bonobo_dock_band_append, METH_VARARGS|METH_KEYWORDS },
    { "set_child_offset", (PyCFunction)_wrap_bonobo_dock_band_set_child_offset, METH_VARARGS|METH_KEYWORDS },
    { "get_child_offset", (PyCFunction)_wrap_bonobo_dock_band_get_child_offset, METH_VARARGS|METH_KEYWORDS },
    { "get_num_children", (PyCFunction)_wrap_bonobo_dock_band_get_num_children, METH_NOARGS },
    { "drag_begin", (PyCFunction)_wrap_bonobo_dock_band_drag_begin, METH_VARARGS|METH_KEYWORDS },
    { "drag_to", (PyCFunction)_wrap_bonobo_dock_band_drag_to, METH_VARARGS|METH_KEYWORDS },
    { "drag_end", (PyCFunction)_wrap_bonobo_dock_band_drag_end, METH_VARARGS|METH_KEYWORDS },
    { NULL, NULL, 0 }
};

PyTypeObject PyBonoboDockBand_Type = {
    PyObject_HEAD_INIT(NULL)
    0,					/* ob_size */
    "bonobo.ui.DockBand",			/* tp_name */
    sizeof(PyGObject),	        /* tp_basicsize */
    0,					/* tp_itemsize */
    /* methods */
    (destructor)0,			/* tp_dealloc */
    (printfunc)0,			/* tp_print */
    (getattrfunc)0,	/* tp_getattr */
    (setattrfunc)0,	/* tp_setattr */
    (cmpfunc)0,		/* tp_compare */
    (reprfunc)0,		/* tp_repr */
    0,			/* tp_as_number */
    0,		/* tp_as_sequence */
    0,			/* tp_as_mapping */
    (hashfunc)0,		/* tp_hash */
    (ternaryfunc)0,		/* tp_call */
    (reprfunc)0,		/* tp_str */
    (getattrofunc)0,			/* tp_getattro */
    (setattrofunc)0,			/* tp_setattro */
    0,					/* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /* tp_flags */
    NULL, 				/* Documentation string */
    (traverseproc)0,			/* tp_traverse */
    (inquiry)0,			/* tp_clear */
    (richcmpfunc)0,	/* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,		/* tp_iter */
    (iternextfunc)0,	/* tp_iternext */
    _PyBonoboDockBand_methods,			/* tp_methods */
    0,					/* tp_members */
    0,		       	/* tp_getset */
    NULL,				/* tp_base */
    NULL,				/* tp_dict */
    (descrgetfunc)0,	/* tp_descr_get */
    (descrsetfunc)0,	/* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)_wrap_bonobo_dock_band_new,		/* tp_init */
};



/* ----------- BonoboDockItem ----------- */

static int
_wrap_bonobo_dock_item_new(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "name", "behavior", NULL };
    char *name;
    BonoboDockItemBehavior behavior;
    PyObject *py_behavior = NULL;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "sO:BonoboDockItem.__init__", kwlist, &name, &py_behavior))
        return -1;
    if (pyg_flags_get_value(BONOBO_TYPE_DOCK_ITEM_BEHAVIOR, py_behavior, (gint *)&behavior))
        return -1;
    self->obj = (GObject *)bonobo_dock_item_new(name, behavior);

    if (!self->obj) {
        PyErr_SetString(PyExc_RuntimeError, "could not create BonoboDockItem object");
        return -1;
    }
    pygobject_register_wrapper((PyObject *)self);
    return 0;
}

static PyObject *
_wrap_bonobo_dock_item_get_child(PyGObject *self)
{
    GtkWidget *ret;

    ret = bonobo_dock_item_get_child(BONOBO_DOCK_ITEM(self->obj));
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyObject *
_wrap_bonobo_dock_item_get_name(PyGObject *self)
{
    gchar *ret;

    ret = bonobo_dock_item_get_name(BONOBO_DOCK_ITEM(self->obj));
    if (ret) {
        PyObject *py_ret = PyString_FromString(ret);
        g_free(ret);
        return py_ret;
    }
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_dock_item_set_shadow_type(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "type", NULL };
    PyObject *py_type = NULL;
    GtkShadowType type;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O:BonoboDockItem.set_shadow_type", kwlist, &py_type))
        return NULL;
    if (pyg_enum_get_value(GTK_TYPE_SHADOW_TYPE, py_type, (gint *)&type))
        return NULL;
    bonobo_dock_item_set_shadow_type(BONOBO_DOCK_ITEM(self->obj), type);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_dock_item_get_shadow_type(PyGObject *self)
{
    gint ret;

    ret = bonobo_dock_item_get_shadow_type(BONOBO_DOCK_ITEM(self->obj));
    return PyInt_FromLong(ret);
}

static PyObject *
_wrap_bonobo_dock_item_set_orientation(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "orientation", NULL };
    GtkOrientation orientation;
    PyObject *py_orientation = NULL, *py_ret;
    int ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O:BonoboDockItem.set_orientation", kwlist, &py_orientation))
        return NULL;
    if (pyg_enum_get_value(GTK_TYPE_ORIENTATION, py_orientation, (gint *)&orientation))
        return NULL;
    ret = bonobo_dock_item_set_orientation(BONOBO_DOCK_ITEM(self->obj), orientation);
    py_ret = ret ? Py_True : Py_False;
    Py_INCREF(py_ret);
    return py_ret;
}

static PyObject *
_wrap_bonobo_dock_item_get_orientation(PyGObject *self)
{
    gint ret;

    ret = bonobo_dock_item_get_orientation(BONOBO_DOCK_ITEM(self->obj));
    return PyInt_FromLong(ret);
}

static PyObject *
_wrap_bonobo_dock_item_get_behavior(PyGObject *self)
{
    guint ret;

    ret = bonobo_dock_item_get_behavior(BONOBO_DOCK_ITEM(self->obj));
    return PyInt_FromLong(ret);
}

static PyMethodDef _PyBonoboDockItem_methods[] = {
    { "get_child", (PyCFunction)_wrap_bonobo_dock_item_get_child, METH_NOARGS },
    { "get_name", (PyCFunction)_wrap_bonobo_dock_item_get_name, METH_NOARGS },
    { "set_shadow_type", (PyCFunction)_wrap_bonobo_dock_item_set_shadow_type, METH_VARARGS|METH_KEYWORDS },
    { "get_shadow_type", (PyCFunction)_wrap_bonobo_dock_item_get_shadow_type, METH_NOARGS },
    { "set_orientation", (PyCFunction)_wrap_bonobo_dock_item_set_orientation, METH_VARARGS|METH_KEYWORDS },
    { "get_orientation", (PyCFunction)_wrap_bonobo_dock_item_get_orientation, METH_NOARGS },
    { "get_behavior", (PyCFunction)_wrap_bonobo_dock_item_get_behavior, METH_NOARGS },
    { NULL, NULL, 0 }
};

PyTypeObject PyBonoboDockItem_Type = {
    PyObject_HEAD_INIT(NULL)
    0,					/* ob_size */
    "bonobo.ui.DockItem",			/* tp_name */
    sizeof(PyGObject),	        /* tp_basicsize */
    0,					/* tp_itemsize */
    /* methods */
    (destructor)0,			/* tp_dealloc */
    (printfunc)0,			/* tp_print */
    (getattrfunc)0,	/* tp_getattr */
    (setattrfunc)0,	/* tp_setattr */
    (cmpfunc)0,		/* tp_compare */
    (reprfunc)0,		/* tp_repr */
    0,			/* tp_as_number */
    0,		/* tp_as_sequence */
    0,			/* tp_as_mapping */
    (hashfunc)0,		/* tp_hash */
    (ternaryfunc)0,		/* tp_call */
    (reprfunc)0,		/* tp_str */
    (getattrofunc)0,			/* tp_getattro */
    (setattrofunc)0,			/* tp_setattro */
    0,					/* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /* tp_flags */
    NULL, 				/* Documentation string */
    (traverseproc)0,			/* tp_traverse */
    (inquiry)0,			/* tp_clear */
    (richcmpfunc)0,	/* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,		/* tp_iter */
    (iternextfunc)0,	/* tp_iternext */
    _PyBonoboDockItem_methods,			/* tp_methods */
    0,					/* tp_members */
    0,		       	/* tp_getset */
    NULL,				/* tp_base */
    NULL,				/* tp_dict */
    (descrgetfunc)0,	/* tp_descr_get */
    (descrsetfunc)0,	/* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)_wrap_bonobo_dock_item_new,		/* tp_init */
};



/* ----------- BonoboUIEngine ----------- */

static PyObject *
_wrap_bonobo_ui_engine_deregister_component_by_ref(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "ref", NULL };
    PyObject *ref;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!:BonoboUIEngine.deregister_component_by_ref", kwlist, &PyCORBA_Object_Type, &ref))
        return NULL;
    bonobo_ui_engine_deregister_component_by_ref(BONOBO_UI_ENGINE(self->obj), (Bonobo_Unknown)((PyCORBA_Object *)ref)->objref);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_ui_engine_deregister_component(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "name", NULL };
    char *name;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s:BonoboUIEngine.deregister_component", kwlist, &name))
        return NULL;
    bonobo_ui_engine_deregister_component(BONOBO_UI_ENGINE(self->obj), name);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_ui_engine_register_component(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "name", "component", NULL };
    char *name;
    PyObject *component;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "sO!:BonoboUIEngine.register_component", kwlist, &name, &PyCORBA_Object_Type, &component))
        return NULL;
    bonobo_ui_engine_register_component(BONOBO_UI_ENGINE(self->obj), name, (Bonobo_Unknown)((PyCORBA_Object *)component)->objref);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_ui_engine_get_component(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "name", NULL };
    char *name;
    Bonobo_Unknown ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s:BonoboUIEngine.get_component", kwlist, &name))
        return NULL;
    ret = bonobo_ui_engine_get_component(BONOBO_UI_ENGINE(self->obj), name);
    if (ret != CORBA_OBJECT_NIL)
        return pycorba_object_new(ret);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_ui_engine_config_set_path(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "path", NULL };
    char *path;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s:BonoboUIEngine.config_set_path", kwlist, &path))
        return NULL;
    bonobo_ui_engine_config_set_path(BONOBO_UI_ENGINE(self->obj), path);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_ui_engine_config_get_path(PyGObject *self)
{
    const gchar *ret;

    ret = bonobo_ui_engine_config_get_path(BONOBO_UI_ENGINE(self->obj));
    if (ret)
        return PyString_FromString(ret);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_ui_engine_set_ui_container(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "ui_container", NULL };
    PyGObject *ui_container;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!:BonoboUIEngine.set_ui_container", kwlist, &PyBonoboUIContainer_Type, &ui_container))
        return NULL;
    bonobo_ui_engine_set_ui_container(BONOBO_UI_ENGINE(self->obj), BONOBO_UI_CONTAINER(ui_container->obj));
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_ui_engine_get_ui_container(PyGObject *self)
{
    BonoboUIContainer *ret;

    ret = bonobo_ui_engine_get_ui_container(BONOBO_UI_ENGINE(self->obj));
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyMethodDef _PyBonoboUIEngine_methods[] = {
    { "deregister_component_by_ref", (PyCFunction)_wrap_bonobo_ui_engine_deregister_component_by_ref, METH_VARARGS|METH_KEYWORDS },
    { "deregister_component", (PyCFunction)_wrap_bonobo_ui_engine_deregister_component, METH_VARARGS|METH_KEYWORDS },
    { "register_component", (PyCFunction)_wrap_bonobo_ui_engine_register_component, METH_VARARGS|METH_KEYWORDS },
    { "get_component", (PyCFunction)_wrap_bonobo_ui_engine_get_component, METH_VARARGS|METH_KEYWORDS },
    { "config_set_path", (PyCFunction)_wrap_bonobo_ui_engine_config_set_path, METH_VARARGS|METH_KEYWORDS },
    { "config_get_path", (PyCFunction)_wrap_bonobo_ui_engine_config_get_path, METH_NOARGS },
    { "set_ui_container", (PyCFunction)_wrap_bonobo_ui_engine_set_ui_container, METH_VARARGS|METH_KEYWORDS },
    { "get_ui_container", (PyCFunction)_wrap_bonobo_ui_engine_get_ui_container, METH_NOARGS },
    { NULL, NULL, 0 }
};

PyTypeObject PyBonoboUIEngine_Type = {
    PyObject_HEAD_INIT(NULL)
    0,					/* ob_size */
    "bonobo.ui.Engine",			/* tp_name */
    sizeof(PyGObject),	        /* tp_basicsize */
    0,					/* tp_itemsize */
    /* methods */
    (destructor)0,			/* tp_dealloc */
    (printfunc)0,			/* tp_print */
    (getattrfunc)0,	/* tp_getattr */
    (setattrfunc)0,	/* tp_setattr */
    (cmpfunc)0,		/* tp_compare */
    (reprfunc)0,		/* tp_repr */
    0,			/* tp_as_number */
    0,		/* tp_as_sequence */
    0,			/* tp_as_mapping */
    (hashfunc)0,		/* tp_hash */
    (ternaryfunc)0,		/* tp_call */
    (reprfunc)0,		/* tp_str */
    (getattrofunc)0,			/* tp_getattro */
    (setattrofunc)0,			/* tp_setattro */
    0,					/* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /* tp_flags */
    NULL, 				/* Documentation string */
    (traverseproc)0,			/* tp_traverse */
    (inquiry)0,			/* tp_clear */
    (richcmpfunc)0,	/* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,		/* tp_iter */
    (iternextfunc)0,	/* tp_iternext */
    _PyBonoboUIEngine_methods,			/* tp_methods */
    0,					/* tp_members */
    0,		       	/* tp_getset */
    NULL,				/* tp_base */
    NULL,				/* tp_dict */
    (descrgetfunc)0,	/* tp_descr_get */
    (descrsetfunc)0,	/* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)pygobject_no_constructor,		/* tp_init */
};



/* ----------- BonoboPlug ----------- */

static int
_wrap_bonobo_plug_new(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "socket_id", NULL };
    PyObject *py_socket_id = NULL;
    gulong socket_id;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!:BonoboPlug.__init__", kwlist, &PyLong_Type, &py_socket_id))
        return -1;
    socket_id = PyLong_AsUnsignedLong(py_socket_id);
    self->obj = (GObject *)bonobo_plug_new(socket_id);

    if (!self->obj) {
        PyErr_SetString(PyExc_RuntimeError, "could not create BonoboPlug object");
        return -1;
    }
    g_object_ref(self->obj); /* we don't own the first reference of windows */
    pygobject_register_wrapper((PyObject *)self);
    return 0;
}

PyTypeObject PyBonoboPlug_Type = {
    PyObject_HEAD_INIT(NULL)
    0,					/* ob_size */
    "bonobo.ui.Plug",			/* tp_name */
    sizeof(PyGObject),	        /* tp_basicsize */
    0,					/* tp_itemsize */
    /* methods */
    (destructor)0,			/* tp_dealloc */
    (printfunc)0,			/* tp_print */
    (getattrfunc)0,	/* tp_getattr */
    (setattrfunc)0,	/* tp_setattr */
    (cmpfunc)0,		/* tp_compare */
    (reprfunc)0,		/* tp_repr */
    0,			/* tp_as_number */
    0,		/* tp_as_sequence */
    0,			/* tp_as_mapping */
    (hashfunc)0,		/* tp_hash */
    (ternaryfunc)0,		/* tp_call */
    (reprfunc)0,		/* tp_str */
    (getattrofunc)0,			/* tp_getattro */
    (setattrofunc)0,			/* tp_setattro */
    0,					/* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /* tp_flags */
    NULL, 				/* Documentation string */
    (traverseproc)0,			/* tp_traverse */
    (inquiry)0,			/* tp_clear */
    (richcmpfunc)0,	/* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,		/* tp_iter */
    (iternextfunc)0,	/* tp_iternext */
    NULL,			/* tp_methods */
    0,					/* tp_members */
    0,		       	/* tp_getset */
    NULL,				/* tp_base */
    NULL,				/* tp_dict */
    (descrgetfunc)0,	/* tp_descr_get */
    (descrsetfunc)0,	/* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)_wrap_bonobo_plug_new,		/* tp_init */
};



/* ----------- BonoboPropertyControl ----------- */

static PyObject *
_wrap_bonobo_property_control_changed(PyGObject *self)
{
    CORBA_Environment opt_ev;

    CORBA_exception_init(&opt_ev);
    bonobo_property_control_changed(BONOBO_PROPERTY_CONTROL(self->obj), &opt_ev);
    if (pyorbit_check_ex(&opt_ev))
        return NULL;
    Py_INCREF(Py_None);
    return Py_None;
}

static PyMethodDef _PyBonoboPropertyControl_methods[] = {
    { "changed", (PyCFunction)_wrap_bonobo_property_control_changed, METH_NOARGS },
    { NULL, NULL, 0 }
};

PyTypeObject PyBonoboPropertyControl_Type = {
    PyObject_HEAD_INIT(NULL)
    0,					/* ob_size */
    "bonobo.ui.PropertyControl",			/* tp_name */
    sizeof(PyGObject),	        /* tp_basicsize */
    0,					/* tp_itemsize */
    /* methods */
    (destructor)0,			/* tp_dealloc */
    (printfunc)0,			/* tp_print */
    (getattrfunc)0,	/* tp_getattr */
    (setattrfunc)0,	/* tp_setattr */
    (cmpfunc)0,		/* tp_compare */
    (reprfunc)0,		/* tp_repr */
    0,			/* tp_as_number */
    0,		/* tp_as_sequence */
    0,			/* tp_as_mapping */
    (hashfunc)0,		/* tp_hash */
    (ternaryfunc)0,		/* tp_call */
    (reprfunc)0,		/* tp_str */
    (getattrofunc)0,			/* tp_getattro */
    (setattrofunc)0,			/* tp_setattro */
    0,					/* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /* tp_flags */
    NULL, 				/* Documentation string */
    (traverseproc)0,			/* tp_traverse */
    (inquiry)0,			/* tp_clear */
    (richcmpfunc)0,	/* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,		/* tp_iter */
    (iternextfunc)0,	/* tp_iternext */
    _PyBonoboPropertyControl_methods,			/* tp_methods */
    0,					/* tp_members */
    0,		       	/* tp_getset */
    NULL,				/* tp_base */
    NULL,				/* tp_dict */
    (descrgetfunc)0,	/* tp_descr_get */
    (descrsetfunc)0,	/* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)pygobject_no_constructor,		/* tp_init */
};



/* ----------- BonoboSelector ----------- */

static PyObject *
_wrap_bonobo_selector_get_selected_id(PyGObject *self)
{
    gchar *ret;

    ret = bonobo_selector_get_selected_id(BONOBO_SELECTOR(self->obj));
    if (ret) {
        PyObject *py_ret = PyString_FromString(ret);
        g_free(ret);
        return py_ret;
    }
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_selector_get_selected_name(PyGObject *self)
{
    gchar *ret;

    ret = bonobo_selector_get_selected_name(BONOBO_SELECTOR(self->obj));
    if (ret) {
        PyObject *py_ret = PyString_FromString(ret);
        g_free(ret);
        return py_ret;
    }
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_selector_get_selected_description(PyGObject *self)
{
    gchar *ret;

    ret = bonobo_selector_get_selected_description(BONOBO_SELECTOR(self->obj));
    if (ret) {
        PyObject *py_ret = PyString_FromString(ret);
        g_free(ret);
        return py_ret;
    }
    Py_INCREF(Py_None);
    return Py_None;
}

static PyMethodDef _PyBonoboSelector_methods[] = {
    { "get_selected_id", (PyCFunction)_wrap_bonobo_selector_get_selected_id, METH_NOARGS },
    { "get_selected_name", (PyCFunction)_wrap_bonobo_selector_get_selected_name, METH_NOARGS },
    { "get_selected_description", (PyCFunction)_wrap_bonobo_selector_get_selected_description, METH_NOARGS },
    { NULL, NULL, 0 }
};

PyTypeObject PyBonoboSelector_Type = {
    PyObject_HEAD_INIT(NULL)
    0,					/* ob_size */
    "bonobo.ui.Selector",			/* tp_name */
    sizeof(PyGObject),	        /* tp_basicsize */
    0,					/* tp_itemsize */
    /* methods */
    (destructor)0,			/* tp_dealloc */
    (printfunc)0,			/* tp_print */
    (getattrfunc)0,	/* tp_getattr */
    (setattrfunc)0,	/* tp_setattr */
    (cmpfunc)0,		/* tp_compare */
    (reprfunc)0,		/* tp_repr */
    0,			/* tp_as_number */
    0,		/* tp_as_sequence */
    0,			/* tp_as_mapping */
    (hashfunc)0,		/* tp_hash */
    (ternaryfunc)0,		/* tp_call */
    (reprfunc)0,		/* tp_str */
    (getattrofunc)0,			/* tp_getattro */
    (setattrofunc)0,			/* tp_setattro */
    0,					/* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /* tp_flags */
    NULL, 				/* Documentation string */
    (traverseproc)0,			/* tp_traverse */
    (inquiry)0,			/* tp_clear */
    (richcmpfunc)0,	/* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,		/* tp_iter */
    (iternextfunc)0,	/* tp_iternext */
    _PyBonoboSelector_methods,			/* tp_methods */
    0,					/* tp_members */
    0,		       	/* tp_getset */
    NULL,				/* tp_base */
    NULL,				/* tp_dict */
    (descrgetfunc)0,	/* tp_descr_get */
    (descrsetfunc)0,	/* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)pygobject_no_constructor,		/* tp_init */
};



/* ----------- BonoboSelectorWidget ----------- */

static PyObject *
_wrap_bonobo_selector_widget_get_id(PyGObject *self)
{
    gchar *ret;

    ret = bonobo_selector_widget_get_id(BONOBO_SELECTOR_WIDGET(self->obj));
    if (ret) {
        PyObject *py_ret = PyString_FromString(ret);
        g_free(ret);
        return py_ret;
    }
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_selector_widget_get_name(PyGObject *self)
{
    gchar *ret;

    ret = bonobo_selector_widget_get_name(BONOBO_SELECTOR_WIDGET(self->obj));
    if (ret) {
        PyObject *py_ret = PyString_FromString(ret);
        g_free(ret);
        return py_ret;
    }
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_selector_widget_get_description(PyGObject *self)
{
    gchar *ret;

    ret = bonobo_selector_widget_get_description(BONOBO_SELECTOR_WIDGET(self->obj));
    if (ret) {
        PyObject *py_ret = PyString_FromString(ret);
        g_free(ret);
        return py_ret;
    }
    Py_INCREF(Py_None);
    return Py_None;
}

static PyMethodDef _PyBonoboSelectorWidget_methods[] = {
    { "get_id", (PyCFunction)_wrap_bonobo_selector_widget_get_id, METH_NOARGS },
    { "get_name", (PyCFunction)_wrap_bonobo_selector_widget_get_name, METH_NOARGS },
    { "get_description", (PyCFunction)_wrap_bonobo_selector_widget_get_description, METH_NOARGS },
    { NULL, NULL, 0 }
};

PyTypeObject PyBonoboSelectorWidget_Type = {
    PyObject_HEAD_INIT(NULL)
    0,					/* ob_size */
    "bonobo.ui.SelectorWidget",			/* tp_name */
    sizeof(PyGObject),	        /* tp_basicsize */
    0,					/* tp_itemsize */
    /* methods */
    (destructor)0,			/* tp_dealloc */
    (printfunc)0,			/* tp_print */
    (getattrfunc)0,	/* tp_getattr */
    (setattrfunc)0,	/* tp_setattr */
    (cmpfunc)0,		/* tp_compare */
    (reprfunc)0,		/* tp_repr */
    0,			/* tp_as_number */
    0,		/* tp_as_sequence */
    0,			/* tp_as_mapping */
    (hashfunc)0,		/* tp_hash */
    (ternaryfunc)0,		/* tp_call */
    (reprfunc)0,		/* tp_str */
    (getattrofunc)0,			/* tp_getattro */
    (setattrofunc)0,			/* tp_setattro */
    0,					/* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /* tp_flags */
    NULL, 				/* Documentation string */
    (traverseproc)0,			/* tp_traverse */
    (inquiry)0,			/* tp_clear */
    (richcmpfunc)0,	/* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,		/* tp_iter */
    (iternextfunc)0,	/* tp_iternext */
    _PyBonoboSelectorWidget_methods,			/* tp_methods */
    0,					/* tp_members */
    0,		       	/* tp_getset */
    NULL,				/* tp_base */
    NULL,				/* tp_dict */
    (descrgetfunc)0,	/* tp_descr_get */
    (descrsetfunc)0,	/* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)pygobject_no_constructor,		/* tp_init */
};



/* ----------- BonoboSocket ----------- */

static int
_wrap_bonobo_socket_new(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { NULL };

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, ":BonoboSocket.__init__", kwlist))
        return -1;
    self->obj = (GObject *)bonobo_socket_new();

    if (!self->obj) {
        PyErr_SetString(PyExc_RuntimeError, "could not create BonoboSocket object");
        return -1;
    }
    pygobject_register_wrapper((PyObject *)self);
    return 0;
}

PyTypeObject PyBonoboSocket_Type = {
    PyObject_HEAD_INIT(NULL)
    0,					/* ob_size */
    "bonobo.ui.Socket",			/* tp_name */
    sizeof(PyGObject),	        /* tp_basicsize */
    0,					/* tp_itemsize */
    /* methods */
    (destructor)0,			/* tp_dealloc */
    (printfunc)0,			/* tp_print */
    (getattrfunc)0,	/* tp_getattr */
    (setattrfunc)0,	/* tp_setattr */
    (cmpfunc)0,		/* tp_compare */
    (reprfunc)0,		/* tp_repr */
    0,			/* tp_as_number */
    0,		/* tp_as_sequence */
    0,			/* tp_as_mapping */
    (hashfunc)0,		/* tp_hash */
    (ternaryfunc)0,		/* tp_call */
    (reprfunc)0,		/* tp_str */
    (getattrofunc)0,			/* tp_getattro */
    (setattrofunc)0,			/* tp_setattro */
    0,					/* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /* tp_flags */
    NULL, 				/* Documentation string */
    (traverseproc)0,			/* tp_traverse */
    (inquiry)0,			/* tp_clear */
    (richcmpfunc)0,	/* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,		/* tp_iter */
    (iternextfunc)0,	/* tp_iternext */
    NULL,			/* tp_methods */
    0,					/* tp_members */
    0,		       	/* tp_getset */
    NULL,				/* tp_base */
    NULL,				/* tp_dict */
    (descrgetfunc)0,	/* tp_descr_get */
    (descrsetfunc)0,	/* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)_wrap_bonobo_socket_new,		/* tp_init */
};



/* ----------- BonoboUIComponent ----------- */

static int
_wrap_bonobo_ui_component_new(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "name", NULL };
    char *name;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s:BonoboUIComponent.__init__", kwlist, &name))
        return -1;
    self->obj = (GObject *)bonobo_ui_component_new(name);

    if (!self->obj) {
        PyErr_SetString(PyExc_RuntimeError, "could not create BonoboUIComponent object");
        return -1;
    }
    pygobject_register_wrapper((PyObject *)self);
    return 0;
}

static PyObject *
_wrap_bonobo_ui_component_set_name(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "name", NULL };
    char *name;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s:BonoboUIComponent.set_name", kwlist, &name))
        return NULL;
    bonobo_ui_component_set_name(BONOBO_UI_COMPONENT(self->obj), name);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_ui_component_get_name(PyGObject *self)
{
    const gchar *ret;

    ret = bonobo_ui_component_get_name(BONOBO_UI_COMPONENT(self->obj));
    if (ret)
        return PyString_FromString(ret);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_ui_component_set_container(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "container", NULL };
    PyObject *container;
    CORBA_Environment opt_ev;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!:BonoboUIComponent.set_container", kwlist, &PyCORBA_Object_Type, &container))
        return NULL;
    CORBA_exception_init(&opt_ev);
    bonobo_ui_component_set_container(BONOBO_UI_COMPONENT(self->obj), (Bonobo_UIContainer)((PyCORBA_Object *)container)->objref, &opt_ev);
    if (pyorbit_check_ex(&opt_ev))
        return NULL;
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_ui_component_unset_container(PyGObject *self)
{
    CORBA_Environment opt_ev;

    CORBA_exception_init(&opt_ev);
    bonobo_ui_component_unset_container(BONOBO_UI_COMPONENT(self->obj), &opt_ev);
    if (pyorbit_check_ex(&opt_ev))
        return NULL;
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_ui_component_get_container(PyGObject *self)
{
    Bonobo_UIContainer ret;

    ret = bonobo_ui_component_get_container(BONOBO_UI_COMPONENT(self->obj));
    if (ret != CORBA_OBJECT_NIL)
        return pycorba_object_new(ret);
    Py_INCREF(Py_None);
    return Py_None;
}

#line 44 "bonoboui.override"
static PyObject *
_wrap_bonobo_ui_component_add_verb (PyGObject * self,
				    PyObject *  args,
				    PyObject *  kwargs)
{
    static char *kwlist[] = { "cname", "callback", "extra_data", NULL };
    PyObject *callback, *param=NULL;
    char *cname;

    if (!PyArg_ParseTupleAndKeywords (args, kwargs,
				      "sO|O:BonoboUIComponent.add_verb", kwlist,
				      &cname, &callback, &param)) {
	return NULL;
    }

    if (!PyCallable_Check (callback)) {
        PyErr_SetString (PyExc_TypeError, "second arg not callable");
	return NULL;
    }

    bonobo_ui_component_add_verb_full (BONOBO_UI_COMPONENT (self->obj),
				       cname,
				       pyg_closure_new (callback, param, NULL));
    Py_INCREF (Py_None);
    return Py_None;
}
#line 2060 "bonoboui.c"


static PyObject *
_wrap_bonobo_ui_component_remove_verb(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "cname", NULL };
    char *cname;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s:BonoboUIComponent.remove_verb", kwlist, &cname))
        return NULL;
    bonobo_ui_component_remove_verb(BONOBO_UI_COMPONENT(self->obj), cname);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_ui_component_remove_listener(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "cname", NULL };
    char *cname;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s:BonoboUIComponent.remove_listener", kwlist, &cname))
        return NULL;
    bonobo_ui_component_remove_listener(BONOBO_UI_COMPONENT(self->obj), cname);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_ui_component_set(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "path", "xml", NULL };
    char *path, *xml;
    CORBA_Environment opt_ev;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "ss:BonoboUIComponent.set", kwlist, &path, &xml))
        return NULL;
    CORBA_exception_init(&opt_ev);
    bonobo_ui_component_set(BONOBO_UI_COMPONENT(self->obj), path, xml, &opt_ev);
    if (pyorbit_check_ex(&opt_ev))
        return NULL;
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_ui_component_set_translate(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "path", "xml", NULL };
    char *path, *xml;
    CORBA_Environment opt_ev;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "ss:BonoboUIComponent.set_translate", kwlist, &path, &xml))
        return NULL;
    CORBA_exception_init(&opt_ev);
    bonobo_ui_component_set_translate(BONOBO_UI_COMPONENT(self->obj), path, xml, &opt_ev);
    if (pyorbit_check_ex(&opt_ev))
        return NULL;
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_ui_component_rm(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "path", NULL };
    char *path;
    CORBA_Environment ev;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s:BonoboUIComponent.rm", kwlist, &path))
        return NULL;
    CORBA_exception_init(&ev);
    bonobo_ui_component_rm(BONOBO_UI_COMPONENT(self->obj), path, &ev);
    if (pyorbit_check_ex(&ev))
        return NULL;
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_ui_component_path_exists(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "path", NULL };
    char *path;
    CORBA_Environment ev;
    int ret;
    PyObject *py_ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s:BonoboUIComponent.path_exists", kwlist, &path))
        return NULL;
    CORBA_exception_init(&ev);
    ret = bonobo_ui_component_path_exists(BONOBO_UI_COMPONENT(self->obj), path, &ev);
    if (pyorbit_check_ex(&ev))
        return NULL;
    py_ret = ret ? Py_True : Py_False;
    Py_INCREF(py_ret);
    return py_ret;
}

static PyObject *
_wrap_bonobo_ui_component_get(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "path", "recurse", NULL };
    char *path;
    int recurse;
    CORBA_Environment opt_ev;
    const gchar *ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "si:BonoboUIComponent.get", kwlist, &path, &recurse))
        return NULL;
    CORBA_exception_init(&opt_ev);
    ret = bonobo_ui_component_get(BONOBO_UI_COMPONENT(self->obj), path, recurse, &opt_ev);
    if (pyorbit_check_ex(&opt_ev))
        return NULL;
    if (ret)
        return PyString_FromString(ret);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_ui_component_object_set(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "path", "control", NULL };
    char *path;
    PyObject *control;
    CORBA_Environment ev;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "sO!:BonoboUIComponent.object_set", kwlist, &path, &PyCORBA_Object_Type, &control))
        return NULL;
    CORBA_exception_init(&ev);
    bonobo_ui_component_object_set(BONOBO_UI_COMPONENT(self->obj), path, (Bonobo_Unknown)((PyCORBA_Object *)control)->objref, &ev);
    if (pyorbit_check_ex(&ev))
        return NULL;
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_ui_component_object_get(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "path", NULL };
    char *path;
    CORBA_Environment opt_ev;
    Bonobo_Unknown ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s:BonoboUIComponent.object_get", kwlist, &path))
        return NULL;
    CORBA_exception_init(&opt_ev);
    ret = bonobo_ui_component_object_get(BONOBO_UI_COMPONENT(self->obj), path, &opt_ev);
    if (pyorbit_check_ex(&opt_ev))
        return NULL;
    if (ret != CORBA_OBJECT_NIL)
        return pycorba_object_new(ret);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_ui_component_freeze(PyGObject *self)
{
    CORBA_Environment opt_ev;

    CORBA_exception_init(&opt_ev);
    bonobo_ui_component_freeze(BONOBO_UI_COMPONENT(self->obj), &opt_ev);
    if (pyorbit_check_ex(&opt_ev))
        return NULL;
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_ui_component_thaw(PyGObject *self)
{
    CORBA_Environment opt_ev;

    CORBA_exception_init(&opt_ev);
    bonobo_ui_component_thaw(BONOBO_UI_COMPONENT(self->obj), &opt_ev);
    if (pyorbit_check_ex(&opt_ev))
        return NULL;
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_ui_component_set_prop(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "path", "prop", "value", NULL };
    char *path, *prop, *value;
    CORBA_Environment opt_ev;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "sss:BonoboUIComponent.set_prop", kwlist, &path, &prop, &value))
        return NULL;
    CORBA_exception_init(&opt_ev);
    bonobo_ui_component_set_prop(BONOBO_UI_COMPONENT(self->obj), path, prop, value, &opt_ev);
    if (pyorbit_check_ex(&opt_ev))
        return NULL;
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_ui_component_get_prop(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "path", "prop", NULL };
    char *path, *prop;
    CORBA_Environment opt_ev;
    gchar *ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "ss:BonoboUIComponent.get_prop", kwlist, &path, &prop))
        return NULL;
    CORBA_exception_init(&opt_ev);
    ret = bonobo_ui_component_get_prop(BONOBO_UI_COMPONENT(self->obj), path, prop, &opt_ev);
    if (pyorbit_check_ex(&opt_ev))
        return NULL;
    if (ret) {
        PyObject *py_ret = PyString_FromString(ret);
        g_free(ret);
        return py_ret;
    }
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_ui_component_set_status(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "text", NULL };
    char *text;
    CORBA_Environment opt_ev;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s:BonoboUIComponent.set_status", kwlist, &text))
        return NULL;
    CORBA_exception_init(&opt_ev);
    bonobo_ui_component_set_status(BONOBO_UI_COMPONENT(self->obj), text, &opt_ev);
    if (pyorbit_check_ex(&opt_ev))
        return NULL;
    Py_INCREF(Py_None);
    return Py_None;
}

#line 72 "bonoboui.override"
static PyObject *
_wrap_bonobo_ui_component_add_verb_list (PyGObject * self,
					 PyObject *  args,
					 PyObject *  kwargs)
{
    static char *kwlist[] = { "list", "extra_data", NULL };    
    PyObject *          list;
    PyObject *          params = NULL;
    BonoboUIComponent * uic;
    int                 len, i;
    PyObject *          item;
    char *              cname;
    PyObject *          callback;
    
    if (!PyArg_ParseTupleAndKeywords (args, kwargs,
				      "O|O:BonoboUIComponent.add_verb_list", 
				      kwlist, &list, &params)) {
	return NULL;
    }

    if (!PySequence_Check (list)) {
	PyErr_SetString (PyExc_TypeError, "entries must be a sequence");
	return NULL;
    }

    uic = BONOBO_UI_COMPONENT (self->obj);
    len = PySequence_Size (list);
    for (i = 0; i < len; i++) {
	item = PySequence_GetItem (list, i);
	Py_DECREF (item);
	
	if (!PyArg_ParseTuple (item, "sO", &cname, &callback)) {
	    return NULL;
	}

	bonobo_ui_component_add_verb_full (uic, cname,
					   pyg_closure_new (callback, params, NULL));
    }

    Py_INCREF(Py_None);
    return Py_None;
}
#line 2345 "bonoboui.c"


static PyMethodDef _PyBonoboUIComponent_methods[] = {
    { "set_name", (PyCFunction)_wrap_bonobo_ui_component_set_name, METH_VARARGS|METH_KEYWORDS },
    { "get_name", (PyCFunction)_wrap_bonobo_ui_component_get_name, METH_NOARGS },
    { "set_container", (PyCFunction)_wrap_bonobo_ui_component_set_container, METH_VARARGS|METH_KEYWORDS },
    { "unset_container", (PyCFunction)_wrap_bonobo_ui_component_unset_container, METH_NOARGS },
    { "get_container", (PyCFunction)_wrap_bonobo_ui_component_get_container, METH_NOARGS },
    { "add_verb", (PyCFunction)_wrap_bonobo_ui_component_add_verb, METH_VARARGS|METH_KEYWORDS },
    { "remove_verb", (PyCFunction)_wrap_bonobo_ui_component_remove_verb, METH_VARARGS|METH_KEYWORDS },
    { "remove_listener", (PyCFunction)_wrap_bonobo_ui_component_remove_listener, METH_VARARGS|METH_KEYWORDS },
    { "set", (PyCFunction)_wrap_bonobo_ui_component_set, METH_VARARGS|METH_KEYWORDS },
    { "set_translate", (PyCFunction)_wrap_bonobo_ui_component_set_translate, METH_VARARGS|METH_KEYWORDS },
    { "rm", (PyCFunction)_wrap_bonobo_ui_component_rm, METH_VARARGS|METH_KEYWORDS },
    { "path_exists", (PyCFunction)_wrap_bonobo_ui_component_path_exists, METH_VARARGS|METH_KEYWORDS },
    { "get", (PyCFunction)_wrap_bonobo_ui_component_get, METH_VARARGS|METH_KEYWORDS },
    { "object_set", (PyCFunction)_wrap_bonobo_ui_component_object_set, METH_VARARGS|METH_KEYWORDS },
    { "object_get", (PyCFunction)_wrap_bonobo_ui_component_object_get, METH_VARARGS|METH_KEYWORDS },
    { "freeze", (PyCFunction)_wrap_bonobo_ui_component_freeze, METH_NOARGS },
    { "thaw", (PyCFunction)_wrap_bonobo_ui_component_thaw, METH_NOARGS },
    { "set_prop", (PyCFunction)_wrap_bonobo_ui_component_set_prop, METH_VARARGS|METH_KEYWORDS },
    { "get_prop", (PyCFunction)_wrap_bonobo_ui_component_get_prop, METH_VARARGS|METH_KEYWORDS },
    { "set_status", (PyCFunction)_wrap_bonobo_ui_component_set_status, METH_VARARGS|METH_KEYWORDS },
    { "add_verb_list", (PyCFunction)_wrap_bonobo_ui_component_add_verb_list, METH_VARARGS|METH_KEYWORDS },
    { NULL, NULL, 0 }
};

PyTypeObject PyBonoboUIComponent_Type = {
    PyObject_HEAD_INIT(NULL)
    0,					/* ob_size */
    "bonobo.ui.Component",			/* tp_name */
    sizeof(PyGObject),	        /* tp_basicsize */
    0,					/* tp_itemsize */
    /* methods */
    (destructor)0,			/* tp_dealloc */
    (printfunc)0,			/* tp_print */
    (getattrfunc)0,	/* tp_getattr */
    (setattrfunc)0,	/* tp_setattr */
    (cmpfunc)0,		/* tp_compare */
    (reprfunc)0,		/* tp_repr */
    0,			/* tp_as_number */
    0,		/* tp_as_sequence */
    0,			/* tp_as_mapping */
    (hashfunc)0,		/* tp_hash */
    (ternaryfunc)0,		/* tp_call */
    (reprfunc)0,		/* tp_str */
    (getattrofunc)0,			/* tp_getattro */
    (setattrofunc)0,			/* tp_setattro */
    0,					/* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /* tp_flags */
    NULL, 				/* Documentation string */
    (traverseproc)0,			/* tp_traverse */
    (inquiry)0,			/* tp_clear */
    (richcmpfunc)0,	/* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,		/* tp_iter */
    (iternextfunc)0,	/* tp_iternext */
    _PyBonoboUIComponent_methods,			/* tp_methods */
    0,					/* tp_members */
    0,		       	/* tp_getset */
    NULL,				/* tp_base */
    NULL,				/* tp_dict */
    (descrgetfunc)0,	/* tp_descr_get */
    (descrsetfunc)0,	/* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)_wrap_bonobo_ui_component_new,		/* tp_init */
};



/* ----------- BonoboUIContainer ----------- */

static int
_wrap_bonobo_ui_container_new(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { NULL };

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, ":BonoboUIContainer.__init__", kwlist))
        return -1;
    self->obj = (GObject *)bonobo_ui_container_new();

    if (!self->obj) {
        PyErr_SetString(PyExc_RuntimeError, "could not create BonoboUIContainer object");
        return -1;
    }
    pygobject_register_wrapper((PyObject *)self);
    return 0;
}

PyTypeObject PyBonoboUIContainer_Type = {
    PyObject_HEAD_INIT(NULL)
    0,					/* ob_size */
    "bonobo.ui.Container",			/* tp_name */
    sizeof(PyGObject),	        /* tp_basicsize */
    0,					/* tp_itemsize */
    /* methods */
    (destructor)0,			/* tp_dealloc */
    (printfunc)0,			/* tp_print */
    (getattrfunc)0,	/* tp_getattr */
    (setattrfunc)0,	/* tp_setattr */
    (cmpfunc)0,		/* tp_compare */
    (reprfunc)0,		/* tp_repr */
    0,			/* tp_as_number */
    0,		/* tp_as_sequence */
    0,			/* tp_as_mapping */
    (hashfunc)0,		/* tp_hash */
    (ternaryfunc)0,		/* tp_call */
    (reprfunc)0,		/* tp_str */
    (getattrofunc)0,			/* tp_getattro */
    (setattrofunc)0,			/* tp_setattro */
    0,					/* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /* tp_flags */
    NULL, 				/* Documentation string */
    (traverseproc)0,			/* tp_traverse */
    (inquiry)0,			/* tp_clear */
    (richcmpfunc)0,	/* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,		/* tp_iter */
    (iternextfunc)0,	/* tp_iternext */
    NULL,			/* tp_methods */
    0,					/* tp_members */
    0,		       	/* tp_getset */
    NULL,				/* tp_base */
    NULL,				/* tp_dict */
    (descrgetfunc)0,	/* tp_descr_get */
    (descrsetfunc)0,	/* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)_wrap_bonobo_ui_container_new,		/* tp_init */
};



/* ----------- BonoboUIToolbar ----------- */

static int
_wrap_bonobo_ui_toolbar_new(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { NULL };

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, ":BonoboUIToolbar.__init__", kwlist))
        return -1;
    self->obj = (GObject *)bonobo_ui_toolbar_new();

    if (!self->obj) {
        PyErr_SetString(PyExc_RuntimeError, "could not create BonoboUIToolbar object");
        return -1;
    }
    pygobject_register_wrapper((PyObject *)self);
    return 0;
}

static PyObject *
_wrap_bonobo_ui_toolbar_set_orientation(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "orientation", NULL };
    GtkOrientation orientation;
    PyObject *py_orientation = NULL;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O:BonoboUIToolbar.set_orientation", kwlist, &py_orientation))
        return NULL;
    if (pyg_enum_get_value(GTK_TYPE_ORIENTATION, py_orientation, (gint *)&orientation))
        return NULL;
    bonobo_ui_toolbar_set_orientation(BONOBO_UI_TOOLBAR(self->obj), orientation);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_ui_toolbar_get_orientation(PyGObject *self)
{
    gint ret;

    ret = bonobo_ui_toolbar_get_orientation(BONOBO_UI_TOOLBAR(self->obj));
    return PyInt_FromLong(ret);
}

static PyObject *
_wrap_bonobo_ui_toolbar_get_style(PyGObject *self)
{
    gint ret;

    ret = bonobo_ui_toolbar_get_style(BONOBO_UI_TOOLBAR(self->obj));
    return PyInt_FromLong(ret);
}

static PyObject *
_wrap_bonobo_ui_toolbar_set_hv_styles(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "hstyle", "vstyle", NULL };
    PyObject *py_hstyle = NULL, *py_vstyle = NULL;
    BonoboUIToolbarStyle hstyle, vstyle;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "OO:BonoboUIToolbar.set_hv_styles", kwlist, &py_hstyle, &py_vstyle))
        return NULL;
    if (pyg_enum_get_value(BONOBO_TYPE_UI_TOOLBAR_STYLE, py_hstyle, (gint *)&hstyle))
        return NULL;
    if (pyg_enum_get_value(BONOBO_TYPE_UI_TOOLBAR_STYLE, py_vstyle, (gint *)&vstyle))
        return NULL;
    bonobo_ui_toolbar_set_hv_styles(BONOBO_UI_TOOLBAR(self->obj), hstyle, vstyle);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_ui_toolbar_insert(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "item", "position", NULL };
    PyGObject *item;
    int position;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!i:BonoboUIToolbar.insert", kwlist, &PyBonoboUIToolbarItem_Type, &item, &position))
        return NULL;
    bonobo_ui_toolbar_insert(BONOBO_UI_TOOLBAR(self->obj), BONOBO_UI_TOOLBAR_ITEM(item->obj), position);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_ui_toolbar_get_tooltips(PyGObject *self)
{
    GtkTooltips *ret;

    ret = bonobo_ui_toolbar_get_tooltips(BONOBO_UI_TOOLBAR(self->obj));
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyObject *
_wrap_bonobo_ui_toolbar_show_tooltips(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "show_tips", NULL };
    int show_tips;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "i:BonoboUIToolbar.show_tooltips", kwlist, &show_tips))
        return NULL;
    bonobo_ui_toolbar_show_tooltips(BONOBO_UI_TOOLBAR(self->obj), show_tips);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyMethodDef _PyBonoboUIToolbar_methods[] = {
    { "set_orientation", (PyCFunction)_wrap_bonobo_ui_toolbar_set_orientation, METH_VARARGS|METH_KEYWORDS },
    { "get_orientation", (PyCFunction)_wrap_bonobo_ui_toolbar_get_orientation, METH_NOARGS },
    { "get_style", (PyCFunction)_wrap_bonobo_ui_toolbar_get_style, METH_NOARGS },
    { "set_hv_styles", (PyCFunction)_wrap_bonobo_ui_toolbar_set_hv_styles, METH_VARARGS|METH_KEYWORDS },
    { "insert", (PyCFunction)_wrap_bonobo_ui_toolbar_insert, METH_VARARGS|METH_KEYWORDS },
    { "get_tooltips", (PyCFunction)_wrap_bonobo_ui_toolbar_get_tooltips, METH_NOARGS },
    { "show_tooltips", (PyCFunction)_wrap_bonobo_ui_toolbar_show_tooltips, METH_VARARGS|METH_KEYWORDS },
    { NULL, NULL, 0 }
};

PyTypeObject PyBonoboUIToolbar_Type = {
    PyObject_HEAD_INIT(NULL)
    0,					/* ob_size */
    "bonobo.ui.Toolbar",			/* tp_name */
    sizeof(PyGObject),	        /* tp_basicsize */
    0,					/* tp_itemsize */
    /* methods */
    (destructor)0,			/* tp_dealloc */
    (printfunc)0,			/* tp_print */
    (getattrfunc)0,	/* tp_getattr */
    (setattrfunc)0,	/* tp_setattr */
    (cmpfunc)0,		/* tp_compare */
    (reprfunc)0,		/* tp_repr */
    0,			/* tp_as_number */
    0,		/* tp_as_sequence */
    0,			/* tp_as_mapping */
    (hashfunc)0,		/* tp_hash */
    (ternaryfunc)0,		/* tp_call */
    (reprfunc)0,		/* tp_str */
    (getattrofunc)0,			/* tp_getattro */
    (setattrofunc)0,			/* tp_setattro */
    0,					/* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /* tp_flags */
    NULL, 				/* Documentation string */
    (traverseproc)0,			/* tp_traverse */
    (inquiry)0,			/* tp_clear */
    (richcmpfunc)0,	/* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,		/* tp_iter */
    (iternextfunc)0,	/* tp_iternext */
    _PyBonoboUIToolbar_methods,			/* tp_methods */
    0,					/* tp_members */
    0,		       	/* tp_getset */
    NULL,				/* tp_base */
    NULL,				/* tp_dict */
    (descrgetfunc)0,	/* tp_descr_get */
    (descrsetfunc)0,	/* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)_wrap_bonobo_ui_toolbar_new,		/* tp_init */
};



/* ----------- BonoboUIToolbarItem ----------- */

static int
_wrap_bonobo_ui_toolbar_item_new(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { NULL };

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, ":BonoboUIToolbarItem.__init__", kwlist))
        return -1;
    self->obj = (GObject *)bonobo_ui_toolbar_item_new();

    if (!self->obj) {
        PyErr_SetString(PyExc_RuntimeError, "could not create BonoboUIToolbarItem object");
        return -1;
    }
    pygobject_register_wrapper((PyObject *)self);
    return 0;
}

static PyObject *
_wrap_bonobo_ui_toolbar_item_set_tooltip(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "tooltips", "tooltip", NULL };
    PyGObject *tooltips;
    char *tooltip;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!s:BonoboUIToolbarItem.set_tooltip", kwlist, &PyGtkTooltips_Type, &tooltips, &tooltip))
        return NULL;
    bonobo_ui_toolbar_item_set_tooltip(BONOBO_UI_TOOLBAR_ITEM(self->obj), GTK_TOOLTIPS(tooltips->obj), tooltip);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_ui_toolbar_item_set_state(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "new_state", NULL };
    char *new_state;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s:BonoboUIToolbarItem.set_state", kwlist, &new_state))
        return NULL;
    bonobo_ui_toolbar_item_set_state(BONOBO_UI_TOOLBAR_ITEM(self->obj), new_state);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_ui_toolbar_item_set_orientation(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "orientation", NULL };
    GtkOrientation orientation;
    PyObject *py_orientation = NULL;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O:BonoboUIToolbarItem.set_orientation", kwlist, &py_orientation))
        return NULL;
    if (pyg_enum_get_value(GTK_TYPE_ORIENTATION, py_orientation, (gint *)&orientation))
        return NULL;
    bonobo_ui_toolbar_item_set_orientation(BONOBO_UI_TOOLBAR_ITEM(self->obj), orientation);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_ui_toolbar_item_get_orientation(PyGObject *self)
{
    gint ret;

    ret = bonobo_ui_toolbar_item_get_orientation(BONOBO_UI_TOOLBAR_ITEM(self->obj));
    return PyInt_FromLong(ret);
}

static PyObject *
_wrap_bonobo_ui_toolbar_item_set_style(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "style", NULL };
    PyObject *py_style = NULL;
    BonoboUIToolbarItemStyle style;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O:BonoboUIToolbarItem.set_style", kwlist, &py_style))
        return NULL;
    if (pyg_enum_get_value(BONOBO_TYPE_UI_TOOLBAR_ITEM_STYLE, py_style, (gint *)&style))
        return NULL;
    bonobo_ui_toolbar_item_set_style(BONOBO_UI_TOOLBAR_ITEM(self->obj), style);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_ui_toolbar_item_get_style(PyGObject *self)
{
    gint ret;

    ret = bonobo_ui_toolbar_item_get_style(BONOBO_UI_TOOLBAR_ITEM(self->obj));
    return PyInt_FromLong(ret);
}

static PyObject *
_wrap_bonobo_ui_toolbar_item_set_minimum_width(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "minimum_width", NULL };
    int minimum_width;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "i:BonoboUIToolbarItem.set_minimum_width", kwlist, &minimum_width))
        return NULL;
    bonobo_ui_toolbar_item_set_minimum_width(BONOBO_UI_TOOLBAR_ITEM(self->obj), minimum_width);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_ui_toolbar_item_set_want_label(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "prefer_text", NULL };
    int prefer_text;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "i:BonoboUIToolbarItem.set_want_label", kwlist, &prefer_text))
        return NULL;
    bonobo_ui_toolbar_item_set_want_label(BONOBO_UI_TOOLBAR_ITEM(self->obj), prefer_text);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_ui_toolbar_item_get_want_label(PyGObject *self)
{
    int ret;
    PyObject *py_ret;

    ret = bonobo_ui_toolbar_item_get_want_label(BONOBO_UI_TOOLBAR_ITEM(self->obj));
    py_ret = ret ? Py_True : Py_False;
    Py_INCREF(py_ret);
    return py_ret;
}

static PyObject *
_wrap_bonobo_ui_toolbar_item_set_expandable(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "expandable", NULL };
    int expandable;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "i:BonoboUIToolbarItem.set_expandable", kwlist, &expandable))
        return NULL;
    bonobo_ui_toolbar_item_set_expandable(BONOBO_UI_TOOLBAR_ITEM(self->obj), expandable);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_ui_toolbar_item_get_expandable(PyGObject *self)
{
    int ret;
    PyObject *py_ret;

    ret = bonobo_ui_toolbar_item_get_expandable(BONOBO_UI_TOOLBAR_ITEM(self->obj));
    py_ret = ret ? Py_True : Py_False;
    Py_INCREF(py_ret);
    return py_ret;
}

static PyObject *
_wrap_bonobo_ui_toolbar_item_set_pack_end(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "expandable", NULL };
    int expandable;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "i:BonoboUIToolbarItem.set_pack_end", kwlist, &expandable))
        return NULL;
    bonobo_ui_toolbar_item_set_pack_end(BONOBO_UI_TOOLBAR_ITEM(self->obj), expandable);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_ui_toolbar_item_get_pack_end(PyGObject *self)
{
    int ret;
    PyObject *py_ret;

    ret = bonobo_ui_toolbar_item_get_pack_end(BONOBO_UI_TOOLBAR_ITEM(self->obj));
    py_ret = ret ? Py_True : Py_False;
    Py_INCREF(py_ret);
    return py_ret;
}

static PyObject *
_wrap_bonobo_ui_toolbar_item_activate(PyGObject *self)
{
    bonobo_ui_toolbar_item_activate(BONOBO_UI_TOOLBAR_ITEM(self->obj));
    Py_INCREF(Py_None);
    return Py_None;
}

static PyMethodDef _PyBonoboUIToolbarItem_methods[] = {
    { "set_tooltip", (PyCFunction)_wrap_bonobo_ui_toolbar_item_set_tooltip, METH_VARARGS|METH_KEYWORDS },
    { "set_state", (PyCFunction)_wrap_bonobo_ui_toolbar_item_set_state, METH_VARARGS|METH_KEYWORDS },
    { "set_orientation", (PyCFunction)_wrap_bonobo_ui_toolbar_item_set_orientation, METH_VARARGS|METH_KEYWORDS },
    { "get_orientation", (PyCFunction)_wrap_bonobo_ui_toolbar_item_get_orientation, METH_NOARGS },
    { "set_style", (PyCFunction)_wrap_bonobo_ui_toolbar_item_set_style, METH_VARARGS|METH_KEYWORDS },
    { "get_style", (PyCFunction)_wrap_bonobo_ui_toolbar_item_get_style, METH_NOARGS },
    { "set_minimum_width", (PyCFunction)_wrap_bonobo_ui_toolbar_item_set_minimum_width, METH_VARARGS|METH_KEYWORDS },
    { "set_want_label", (PyCFunction)_wrap_bonobo_ui_toolbar_item_set_want_label, METH_VARARGS|METH_KEYWORDS },
    { "get_want_label", (PyCFunction)_wrap_bonobo_ui_toolbar_item_get_want_label, METH_NOARGS },
    { "set_expandable", (PyCFunction)_wrap_bonobo_ui_toolbar_item_set_expandable, METH_VARARGS|METH_KEYWORDS },
    { "get_expandable", (PyCFunction)_wrap_bonobo_ui_toolbar_item_get_expandable, METH_NOARGS },
    { "set_pack_end", (PyCFunction)_wrap_bonobo_ui_toolbar_item_set_pack_end, METH_VARARGS|METH_KEYWORDS },
    { "get_pack_end", (PyCFunction)_wrap_bonobo_ui_toolbar_item_get_pack_end, METH_NOARGS },
    { "activate", (PyCFunction)_wrap_bonobo_ui_toolbar_item_activate, METH_NOARGS },
    { NULL, NULL, 0 }
};

PyTypeObject PyBonoboUIToolbarItem_Type = {
    PyObject_HEAD_INIT(NULL)
    0,					/* ob_size */
    "bonobo.ui.ToolbarItem",			/* tp_name */
    sizeof(PyGObject),	        /* tp_basicsize */
    0,					/* tp_itemsize */
    /* methods */
    (destructor)0,			/* tp_dealloc */
    (printfunc)0,			/* tp_print */
    (getattrfunc)0,	/* tp_getattr */
    (setattrfunc)0,	/* tp_setattr */
    (cmpfunc)0,		/* tp_compare */
    (reprfunc)0,		/* tp_repr */
    0,			/* tp_as_number */
    0,		/* tp_as_sequence */
    0,			/* tp_as_mapping */
    (hashfunc)0,		/* tp_hash */
    (ternaryfunc)0,		/* tp_call */
    (reprfunc)0,		/* tp_str */
    (getattrofunc)0,			/* tp_getattro */
    (setattrofunc)0,			/* tp_setattro */
    0,					/* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /* tp_flags */
    NULL, 				/* Documentation string */
    (traverseproc)0,			/* tp_traverse */
    (inquiry)0,			/* tp_clear */
    (richcmpfunc)0,	/* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,		/* tp_iter */
    (iternextfunc)0,	/* tp_iternext */
    _PyBonoboUIToolbarItem_methods,			/* tp_methods */
    0,					/* tp_members */
    0,		       	/* tp_getset */
    NULL,				/* tp_base */
    NULL,				/* tp_dict */
    (descrgetfunc)0,	/* tp_descr_get */
    (descrsetfunc)0,	/* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)_wrap_bonobo_ui_toolbar_item_new,		/* tp_init */
};



/* ----------- BonoboWidget ----------- */

#line 116 "bonoboui.override"
static int
_wrap_bonobo_widget_new_control(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "object", "uic", NULL };
    PyObject *object;
    PyObject *pyuic;
    CORBA_Environment ev;
    Bonobo_UIContainer uic;
    gboolean is_uic;
    
    if (!PyArg_ParseTupleAndKeywords(args, kwargs,
				     "OO:BonoboWidget.__init__",
				     kwlist, &object, &pyuic)) {
        return -1;
    }

    CORBA_exception_init (&ev);

    is_uic = CORBA_Object_is_a(((PyCORBA_Object *)pyuic)->objref, "IDL:Bonobo/UIContainer:1.0", &ev);
    if (pyorbit_check_ex(&ev))
	return -1;
    if (!is_uic) {
	PyErr_SetString (PyExc_TypeError, "uic must be a Bonobo.UIContainer");
	return -1;
    }
    
    uic = (Bonobo_UIContainer)((PyCORBA_Object *)pyuic)->objref;
	
    if (PyString_Check (object)) {
	self->obj = (GObject *)bonobo_widget_new_control(PyString_AsString (object), uic);
    } else if (PyObject_TypeCheck(object, &PyCORBA_Object_Type)) {
	self->obj = (GObject *)bonobo_widget_new_control_from_objref(((PyCORBA_Object *)object)->objref, uic);
    } else {
	PyErr_SetString(PyExc_TypeError, "object should be a string or a Bonobo.Control");	
	return -1;
    }
    
    if (!self->obj) {
        PyErr_SetString(PyExc_RuntimeError, "could not create BonoboControl object");
        return -1;
    }
    
    pygobject_register_wrapper((PyObject *)self);
    return 0;
}
#line 2941 "bonoboui.c"


static PyObject *
_wrap_bonobo_widget_get_objref(PyGObject *self)
{
    Bonobo_Unknown ret;

    ret = bonobo_widget_get_objref(BONOBO_WIDGET(self->obj));
    if (ret != CORBA_OBJECT_NIL)
        return pycorba_object_new(ret);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_widget_get_control_frame(PyGObject *self)
{
    BonoboControlFrame *ret;

    ret = bonobo_widget_get_control_frame(BONOBO_WIDGET(self->obj));
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyObject *
_wrap_bonobo_widget_get_ui_container(PyGObject *self)
{
    Bonobo_UIContainer ret;

    ret = bonobo_widget_get_ui_container(BONOBO_WIDGET(self->obj));
    if (ret != CORBA_OBJECT_NIL)
        return pycorba_object_new(ret);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_widget_construct_control_from_objref(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "control", "uic", NULL };
    PyObject *control, *uic;
    CORBA_Environment ev;
    BonoboWidget *ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!O!:BonoboWidget.construct_control_from_objref", kwlist, &PyCORBA_Object_Type, &control, &PyCORBA_Object_Type, &uic))
        return NULL;
    CORBA_exception_init(&ev);
    ret = bonobo_widget_construct_control_from_objref(BONOBO_WIDGET(self->obj), (Bonobo_Control)((PyCORBA_Object *)control)->objref, (Bonobo_UIContainer)((PyCORBA_Object *)uic)->objref, &ev);
    if (pyorbit_check_ex(&ev))
        return NULL;
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyObject *
_wrap_bonobo_widget_construct_control(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "moniker", "uic", NULL };
    char *moniker;
    PyObject *uic;
    CORBA_Environment ev;
    BonoboWidget *ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "sO!:BonoboWidget.construct_control", kwlist, &moniker, &PyCORBA_Object_Type, &uic))
        return NULL;
    CORBA_exception_init(&ev);
    ret = bonobo_widget_construct_control(BONOBO_WIDGET(self->obj), moniker, (Bonobo_UIContainer)((PyCORBA_Object *)uic)->objref, &ev);
    if (pyorbit_check_ex(&ev))
        return NULL;
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyMethodDef _PyBonoboWidget_methods[] = {
    { "get_objref", (PyCFunction)_wrap_bonobo_widget_get_objref, METH_NOARGS },
    { "get_control_frame", (PyCFunction)_wrap_bonobo_widget_get_control_frame, METH_NOARGS },
    { "get_ui_container", (PyCFunction)_wrap_bonobo_widget_get_ui_container, METH_NOARGS },
    { "construct_control_from_objref", (PyCFunction)_wrap_bonobo_widget_construct_control_from_objref, METH_VARARGS|METH_KEYWORDS },
    { "construct_control", (PyCFunction)_wrap_bonobo_widget_construct_control, METH_VARARGS|METH_KEYWORDS },
    { NULL, NULL, 0 }
};

PyTypeObject PyBonoboWidget_Type = {
    PyObject_HEAD_INIT(NULL)
    0,					/* ob_size */
    "bonobo.ui.Widget",			/* tp_name */
    sizeof(PyGObject),	        /* tp_basicsize */
    0,					/* tp_itemsize */
    /* methods */
    (destructor)0,			/* tp_dealloc */
    (printfunc)0,			/* tp_print */
    (getattrfunc)0,	/* tp_getattr */
    (setattrfunc)0,	/* tp_setattr */
    (cmpfunc)0,		/* tp_compare */
    (reprfunc)0,		/* tp_repr */
    0,			/* tp_as_number */
    0,		/* tp_as_sequence */
    0,			/* tp_as_mapping */
    (hashfunc)0,		/* tp_hash */
    (ternaryfunc)0,		/* tp_call */
    (reprfunc)0,		/* tp_str */
    (getattrofunc)0,			/* tp_getattro */
    (setattrofunc)0,			/* tp_setattro */
    0,					/* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /* tp_flags */
    NULL, 				/* Documentation string */
    (traverseproc)0,			/* tp_traverse */
    (inquiry)0,			/* tp_clear */
    (richcmpfunc)0,	/* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,		/* tp_iter */
    (iternextfunc)0,	/* tp_iternext */
    _PyBonoboWidget_methods,			/* tp_methods */
    0,					/* tp_members */
    0,		       	/* tp_getset */
    NULL,				/* tp_base */
    NULL,				/* tp_dict */
    (descrgetfunc)0,	/* tp_descr_get */
    (descrsetfunc)0,	/* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)_wrap_bonobo_widget_new_control,		/* tp_init */
};



/* ----------- BonoboWindow ----------- */

static int
_wrap_bonobo_window_new(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "win_name", "title", NULL };
    char *win_name, *title;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "ss:BonoboWindow.__init__", kwlist, &win_name, &title))
        return -1;
    self->obj = (GObject *)bonobo_window_new(win_name, title);

    if (!self->obj) {
        PyErr_SetString(PyExc_RuntimeError, "could not create BonoboWindow object");
        return -1;
    }
    g_object_ref(self->obj); /* we don't own the first reference of windows */
    pygobject_register_wrapper((PyObject *)self);
    return 0;
}

static PyObject *
_wrap_bonobo_window_set_contents(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "contents", NULL };
    PyGObject *contents;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!:BonoboWindow.set_contents", kwlist, &PyGtkWidget_Type, &contents))
        return NULL;
    bonobo_window_set_contents(BONOBO_WINDOW(self->obj), GTK_WIDGET(contents->obj));
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_window_get_contents(PyGObject *self)
{
    GtkWidget *ret;

    ret = bonobo_window_get_contents(BONOBO_WINDOW(self->obj));
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyObject *
_wrap_bonobo_window_get_ui_engine(PyGObject *self)
{
    BonoboUIEngine *ret;

    ret = bonobo_window_get_ui_engine(BONOBO_WINDOW(self->obj));
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyObject *
_wrap_bonobo_window_get_ui_container(PyGObject *self)
{
    BonoboUIContainer *ret;

    ret = bonobo_window_get_ui_container(BONOBO_WINDOW(self->obj));
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyObject *
_wrap_bonobo_window_set_name(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "win_name", NULL };
    char *win_name;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s:BonoboWindow.set_name", kwlist, &win_name))
        return NULL;
    bonobo_window_set_name(BONOBO_WINDOW(self->obj), win_name);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_window_get_name(PyGObject *self)
{
    gchar *ret;

    ret = bonobo_window_get_name(BONOBO_WINDOW(self->obj));
    if (ret) {
        PyObject *py_ret = PyString_FromString(ret);
        g_free(ret);
        return py_ret;
    }
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_window_get_accel_group(PyGObject *self)
{
    GtkAccelGroup *ret;

    ret = bonobo_window_get_accel_group(BONOBO_WINDOW(self->obj));
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyObject *
_wrap_bonobo_window_add_popup(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "popup", "path", NULL };
    PyGObject *popup;
    char *path;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!s:BonoboWindow.add_popup", kwlist, &PyGtkMenu_Type, &popup, &path))
        return NULL;
    bonobo_window_add_popup(BONOBO_WINDOW(self->obj), GTK_MENU(popup->obj), path);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_window_remove_popup(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "path", NULL };
    char *path;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s:BonoboWindow.remove_popup", kwlist, &path))
        return NULL;
    bonobo_window_remove_popup(BONOBO_WINDOW(self->obj), path);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyMethodDef _PyBonoboWindow_methods[] = {
    { "set_contents", (PyCFunction)_wrap_bonobo_window_set_contents, METH_VARARGS|METH_KEYWORDS },
    { "get_contents", (PyCFunction)_wrap_bonobo_window_get_contents, METH_NOARGS },
    { "get_ui_engine", (PyCFunction)_wrap_bonobo_window_get_ui_engine, METH_NOARGS },
    { "get_ui_container", (PyCFunction)_wrap_bonobo_window_get_ui_container, METH_NOARGS },
    { "set_name", (PyCFunction)_wrap_bonobo_window_set_name, METH_VARARGS|METH_KEYWORDS },
    { "get_name", (PyCFunction)_wrap_bonobo_window_get_name, METH_NOARGS },
    { "get_accel_group", (PyCFunction)_wrap_bonobo_window_get_accel_group, METH_NOARGS },
    { "add_popup", (PyCFunction)_wrap_bonobo_window_add_popup, METH_VARARGS|METH_KEYWORDS },
    { "remove_popup", (PyCFunction)_wrap_bonobo_window_remove_popup, METH_VARARGS|METH_KEYWORDS },
    { NULL, NULL, 0 }
};

PyTypeObject PyBonoboWindow_Type = {
    PyObject_HEAD_INIT(NULL)
    0,					/* ob_size */
    "bonobo.ui.Window",			/* tp_name */
    sizeof(PyGObject),	        /* tp_basicsize */
    0,					/* tp_itemsize */
    /* methods */
    (destructor)0,			/* tp_dealloc */
    (printfunc)0,			/* tp_print */
    (getattrfunc)0,	/* tp_getattr */
    (setattrfunc)0,	/* tp_setattr */
    (cmpfunc)0,		/* tp_compare */
    (reprfunc)0,		/* tp_repr */
    0,			/* tp_as_number */
    0,		/* tp_as_sequence */
    0,			/* tp_as_mapping */
    (hashfunc)0,		/* tp_hash */
    (ternaryfunc)0,		/* tp_call */
    (reprfunc)0,		/* tp_str */
    (getattrofunc)0,			/* tp_getattro */
    (setattrofunc)0,			/* tp_setattro */
    0,					/* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /* tp_flags */
    NULL, 				/* Documentation string */
    (traverseproc)0,			/* tp_traverse */
    (inquiry)0,			/* tp_clear */
    (richcmpfunc)0,	/* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,		/* tp_iter */
    (iternextfunc)0,	/* tp_iternext */
    _PyBonoboWindow_methods,			/* tp_methods */
    0,					/* tp_members */
    0,		       	/* tp_getset */
    NULL,				/* tp_base */
    NULL,				/* tp_dict */
    (descrgetfunc)0,	/* tp_descr_get */
    (descrsetfunc)0,	/* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)_wrap_bonobo_window_new,		/* tp_init */
};



/* ----------- functions ----------- */

static PyObject *
_wrap_bonobo_canvas_new(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "is_aa", "proxy", NULL };
    int is_aa;
    PyObject *proxy;
    GnomeCanvas *ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "iO!:bonobo_canvas_new", kwlist, &is_aa, &PyCORBA_Object_Type, &proxy))
        return NULL;
    ret = bonobo_canvas_new(is_aa, (Bonobo_Canvas_ComponentProxy)((PyCORBA_Object *)proxy)->objref);
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyObject *
_wrap_bonobo_control_x11_from_window_id(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "id", NULL };
    char *id;
    gulong ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s:bonobo_control_x11_from_window_id", kwlist, &id))
        return NULL;
    ret = bonobo_control_x11_from_window_id(id);
    return PyLong_FromUnsignedLong(ret);
}

static PyObject *
_wrap_bonobo_file_selector_save(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "parent", "enable_vfs", "title", "mime_types", "default_path", "default_filename", NULL };
    PyGObject *parent;
    int enable_vfs;
    char *title, *mime_types, *default_path, *default_filename;
    gchar *ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!issss:bonobo_file_selector_save", kwlist, &PyGtkWindow_Type, &parent, &enable_vfs, &title, &mime_types, &default_path, &default_filename))
        return NULL;
    ret = bonobo_file_selector_save(GTK_WINDOW(parent->obj), enable_vfs, title, mime_types, default_path, default_filename);
    if (ret) {
        PyObject *py_ret = PyString_FromString(ret);
        g_free(ret);
        return py_ret;
    }
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_selector_widget_new(PyObject *self)
{
    GtkWidget *ret;

    ret = bonobo_selector_widget_new();
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyObject *
_wrap_bonobo_ui_main(PyObject *self)
{
    bonobo_ui_main();
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_setup_x_error_handler(PyObject *self)
{
    bonobo_setup_x_error_handler();
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_ui_debug_shutdown(PyObject *self)
{
    int ret;

    ret = bonobo_ui_debug_shutdown();
    return PyInt_FromLong(ret);
}

static PyObject *
_wrap_bonobo_ui_node_free_string(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "str", NULL };
    char *str;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s:bonobo_ui_node_free_string", kwlist, &str))
        return NULL;
    bonobo_ui_node_free_string(str);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_ui_util_xml_to_pixbuf(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "xml", NULL };
    char *xml;
    GdkPixbuf *ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s:ui_util_xml_to_pixbuf", kwlist, &xml))
        return NULL;
    ret = bonobo_ui_util_xml_to_pixbuf(xml);
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyObject *
_wrap_bonobo_ui_util_get_ui_fname(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "component_prefix", "file_name", NULL };
    char *component_prefix, *file_name;
    gchar *ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "ss:ui_util_get_ui_fname", kwlist, &component_prefix, &file_name))
        return NULL;
    ret = bonobo_ui_util_get_ui_fname(component_prefix, file_name);
    if (ret) {
        PyObject *py_ret = PyString_FromString(ret);
        g_free(ret);
        return py_ret;
    }
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_ui_util_set_ui(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "component", "app_prefix", "file_name", "app_name", NULL };
    PyGObject *component;
    char *app_prefix, *file_name, *app_name;
    CORBA_Environment opt_ev;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!sss:util_set_ui", kwlist, &PyBonoboUIComponent_Type, &component, &app_prefix, &file_name, &app_name))
        return NULL;
    CORBA_exception_init(&opt_ev);
    bonobo_ui_util_set_ui(BONOBO_UI_COMPONENT(component->obj), app_prefix, file_name, app_name, &opt_ev);
    if (pyorbit_check_ex(&opt_ev))
        return NULL;
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_ui_util_set_pixbuf(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "component", "path", "pixbuf", NULL };
    PyGObject *component, *pixbuf;
    char *path;
    CORBA_Environment opt_ev;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!sO!:util_set_pixbuf", kwlist, &PyBonoboUIComponent_Type, &component, &path, &PyGdkPixbuf_Type, &pixbuf))
        return NULL;
    CORBA_exception_init(&opt_ev);
    bonobo_ui_util_set_pixbuf(BONOBO_UI_COMPONENT(component->obj), path, GDK_PIXBUF(pixbuf->obj), &opt_ev);
    if (pyorbit_check_ex(&opt_ev))
        return NULL;
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_ui_util_accel_name(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "accelerator_key", "accelerator_mods", NULL };
    int accelerator_key;
    PyObject *py_accelerator_mods = NULL;
    gchar *ret;
    GdkModifierType accelerator_mods;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "iO:util_accel_name", kwlist, &accelerator_key, &py_accelerator_mods))
        return NULL;
    if (pyg_flags_get_value(GDK_TYPE_MODIFIER_TYPE, py_accelerator_mods, (gint *)&accelerator_mods))
        return NULL;
    ret = bonobo_ui_util_accel_name(accelerator_key, accelerator_mods);
    if (ret) {
        PyObject *py_ret = PyString_FromString(ret);
        g_free(ret);
        return py_ret;
    }
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_widget_new_control_from_objref(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "control", "uic", NULL };
    PyObject *control, *uic, *py_ret;
    GtkWidget *ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!O!:widget_new_control_from_objref", kwlist, &PyCORBA_Object_Type, &control, &PyCORBA_Object_Type, &uic))
        return NULL;
    ret = bonobo_widget_new_control_from_objref((Bonobo_Control)((PyCORBA_Object *)control)->objref, (Bonobo_UIContainer)((PyCORBA_Object *)uic)->objref);
    py_ret = pygobject_new((GObject *)ret);
    g_object_unref(ret);
    return py_ret;
}

PyMethodDef pybonoboui_functions[] = {
    { "bonobo_canvas_new", (PyCFunction)_wrap_bonobo_canvas_new, METH_VARARGS|METH_KEYWORDS },
    { "bonobo_control_x11_from_window_id", (PyCFunction)_wrap_bonobo_control_x11_from_window_id, METH_VARARGS|METH_KEYWORDS },
    { "bonobo_file_selector_save", (PyCFunction)_wrap_bonobo_file_selector_save, METH_VARARGS|METH_KEYWORDS },
    { "bonobo_selector_widget_new", (PyCFunction)_wrap_bonobo_selector_widget_new, METH_NOARGS },
    { "main", (PyCFunction)_wrap_bonobo_ui_main, METH_NOARGS },
    { "setup_x_error_handler", (PyCFunction)_wrap_bonobo_setup_x_error_handler, METH_NOARGS },
    { "debug_shutdown", (PyCFunction)_wrap_bonobo_ui_debug_shutdown, METH_NOARGS },
    { "bonobo_ui_node_free_string", (PyCFunction)_wrap_bonobo_ui_node_free_string, METH_VARARGS|METH_KEYWORDS },
    { "ui_util_xml_to_pixbuf", (PyCFunction)_wrap_bonobo_ui_util_xml_to_pixbuf, METH_VARARGS|METH_KEYWORDS },
    { "ui_util_get_ui_fname", (PyCFunction)_wrap_bonobo_ui_util_get_ui_fname, METH_VARARGS|METH_KEYWORDS },
    { "util_set_ui", (PyCFunction)_wrap_bonobo_ui_util_set_ui, METH_VARARGS|METH_KEYWORDS },
    { "util_set_pixbuf", (PyCFunction)_wrap_bonobo_ui_util_set_pixbuf, METH_VARARGS|METH_KEYWORDS },
    { "util_accel_name", (PyCFunction)_wrap_bonobo_ui_util_accel_name, METH_VARARGS|METH_KEYWORDS },
    { "widget_new_control_from_objref", (PyCFunction)_wrap_bonobo_widget_new_control_from_objref, METH_VARARGS|METH_KEYWORDS },
    { NULL, NULL, 0 }
};


/* ----------- enums and flags ----------- */

void
pybonoboui_add_constants(PyObject *module, const gchar *strip_prefix)
{
    pyg_enum_add_constants(module, BONOBO_TYPE_DOCK_PLACEMENT, strip_prefix);
    pyg_flags_add_constants(module, BONOBO_TYPE_DOCK_ITEM_BEHAVIOR, strip_prefix);
    pyg_enum_add_constants(module, BONOBO_TYPE_UI_ERROR, strip_prefix);
    pyg_enum_add_constants(module, BONOBO_TYPE_UI_TOOLBAR_STYLE, strip_prefix);
    pyg_enum_add_constants(module, BONOBO_TYPE_UI_TOOLBAR_ITEM_STYLE, strip_prefix);
    pyg_enum_add_constants(module, BONOBO_TYPE_UI_ERROR, strip_prefix);
}

/* intialise stuff extension classes */
void
pybonoboui_register_classes(PyObject *d)
{
    PyObject *module;

    if ((module = PyImport_ImportModule("gobject")) != NULL) {
        PyObject *moddict = PyModule_GetDict(module);

        _PyGObject_Type = (PyTypeObject *)PyDict_GetItemString(moddict, "GObject");
    } else {
        Py_FatalError("could not import gobject");
        return;
    }
    if ((module = PyImport_ImportModule("bonobo._bonobo")) != NULL) {
        PyObject *moddict = PyModule_GetDict(module);

        _PyBonoboObject_Type = (PyTypeObject *)PyDict_GetItemString(moddict, "Object");
    } else {
        Py_FatalError("could not import bonobo._bonobo");
        return;
    }
    if ((module = PyImport_ImportModule("gtk.gdk")) != NULL) {
        PyObject *moddict = PyModule_GetDict(module);

        _PyGdkPixbuf_Type = (PyTypeObject *)PyDict_GetItemString(moddict, "Pixbuf");
    } else {
        Py_FatalError("could not import gtk.gdk");
        return;
    }
    if ((module = PyImport_ImportModule("gnome.canvas")) != NULL) {
        PyObject *moddict = PyModule_GetDict(module);

        _PyGnomeCanvasItem_Type = (PyTypeObject *)PyDict_GetItemString(moddict, "CanvasItem");
    } else {
        Py_FatalError("could not import gnome.canvas");
        return;
    }
    if ((module = PyImport_ImportModule("gtk._gtk")) != NULL) {
        PyObject *moddict = PyModule_GetDict(module);

        _PyGtkAccelGroup_Type = (PyTypeObject *)PyDict_GetItemString(moddict, "AccelGroup");
        _PyGtkBin_Type = (PyTypeObject *)PyDict_GetItemString(moddict, "Bin");
        _PyGtkBox_Type = (PyTypeObject *)PyDict_GetItemString(moddict, "Box");
        _PyGtkContainer_Type = (PyTypeObject *)PyDict_GetItemString(moddict, "Container");
        _PyGtkDialog_Type = (PyTypeObject *)PyDict_GetItemString(moddict, "Dialog");
        _PyGtkImage_Type = (PyTypeObject *)PyDict_GetItemString(moddict, "Image");
        _PyGtkMenu_Type = (PyTypeObject *)PyDict_GetItemString(moddict, "Menu");
        _PyGtkMenuBar_Type = (PyTypeObject *)PyDict_GetItemString(moddict, "MenuBar");
        _PyGtkPlug_Type = (PyTypeObject *)PyDict_GetItemString(moddict, "Plug");
        _PyGtkSocket_Type = (PyTypeObject *)PyDict_GetItemString(moddict, "Socket");
        _PyGtkTooltips_Type = (PyTypeObject *)PyDict_GetItemString(moddict, "Tooltips");
        _PyGtkVBox_Type = (PyTypeObject *)PyDict_GetItemString(moddict, "VBox");
        _PyGtkWidget_Type = (PyTypeObject *)PyDict_GetItemString(moddict, "Widget");
        _PyGtkWindow_Type = (PyTypeObject *)PyDict_GetItemString(moddict, "Window");
    } else {
        Py_FatalError("could not import gtk._gtk");
        return;
    }


#line 14 "bonoboui.override"
    init_pyorbit();

#line 3554 "bonoboui.c"
    pygobject_register_class(d, "BonoboCanvasComponent", BONOBO_TYPE_CANVAS_COMPONENT, &PyBonoboCanvasComponent_Type, Py_BuildValue("(O)", &PyBonoboObject_Type));
    pygobject_register_class(d, "BonoboCanvasItem", BONOBO_TYPE_CANVAS_ITEM, &PyBonoboCanvasItem_Type, Py_BuildValue("(O)", &PyGnomeCanvasItem_Type));
    pygobject_register_class(d, "BonoboControl", BONOBO_TYPE_CONTROL, &PyBonoboControl_Type, Py_BuildValue("(O)", &PyBonoboObject_Type));
    pygobject_register_class(d, "BonoboControlFrame", BONOBO_TYPE_CONTROL_FRAME, &PyBonoboControlFrame_Type, Py_BuildValue("(O)", &PyBonoboObject_Type));
    pygobject_register_class(d, "BonoboDock", BONOBO_TYPE_DOCK, &PyBonoboDock_Type, Py_BuildValue("(O)", &PyGtkContainer_Type));
    pygobject_register_class(d, "BonoboDockBand", BONOBO_TYPE_DOCK_BAND, &PyBonoboDockBand_Type, Py_BuildValue("(O)", &PyGtkContainer_Type));
    pygobject_register_class(d, "BonoboDockItem", BONOBO_TYPE_DOCK_ITEM, &PyBonoboDockItem_Type, Py_BuildValue("(O)", &PyGtkBin_Type));
    pygobject_register_class(d, "BonoboUIEngine", BONOBO_TYPE_UI_ENGINE, &PyBonoboUIEngine_Type, Py_BuildValue("(O)", &PyGObject_Type));
    pygobject_register_class(d, "BonoboPlug", BONOBO_TYPE_PLUG, &PyBonoboPlug_Type, Py_BuildValue("(O)", &PyGtkPlug_Type));
    pygobject_register_class(d, "BonoboPropertyControl", BONOBO_TYPE_PROPERTY_CONTROL, &PyBonoboPropertyControl_Type, Py_BuildValue("(O)", &PyBonoboObject_Type));
    pygobject_register_class(d, "BonoboSelector", BONOBO_TYPE_SELECTOR, &PyBonoboSelector_Type, Py_BuildValue("(O)", &PyGtkDialog_Type));
    pygobject_register_class(d, "BonoboSelectorWidget", BONOBO_TYPE_SELECTOR_WIDGET, &PyBonoboSelectorWidget_Type, Py_BuildValue("(O)", &PyGtkVBox_Type));
    pygobject_register_class(d, "BonoboSocket", BONOBO_TYPE_SOCKET, &PyBonoboSocket_Type, Py_BuildValue("(O)", &PyGtkSocket_Type));
    pygobject_register_class(d, "BonoboUIComponent", BONOBO_TYPE_UI_COMPONENT, &PyBonoboUIComponent_Type, Py_BuildValue("(O)", &PyBonoboObject_Type));
    pygobject_register_class(d, "BonoboUIContainer", BONOBO_TYPE_UI_CONTAINER, &PyBonoboUIContainer_Type, Py_BuildValue("(O)", &PyBonoboObject_Type));
    pygobject_register_class(d, "BonoboUIToolbar", BONOBO_TYPE_UI_TOOLBAR, &PyBonoboUIToolbar_Type, Py_BuildValue("(O)", &PyGtkContainer_Type));
    pygobject_register_class(d, "BonoboUIToolbarItem", BONOBO_TYPE_UI_TOOLBAR_ITEM, &PyBonoboUIToolbarItem_Type, Py_BuildValue("(O)", &PyGtkBin_Type));
    pygobject_register_class(d, "BonoboWidget", BONOBO_TYPE_WIDGET, &PyBonoboWidget_Type, Py_BuildValue("(O)", &PyGtkBin_Type));
    pygobject_register_class(d, "BonoboWindow", BONOBO_TYPE_WINDOW, &PyBonoboWindow_Type, Py_BuildValue("(O)", &PyGtkWindow_Type));
}
